/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode)
          || !register_operand (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode)
          || !register_operand (operands[2], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode)
          || !register_operand (operands[2], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 102
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != 100
      || GET_MODE (x4) != E_CCmode
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!icc_register_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern60 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode)
      || !register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern73 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern82 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !symbolic_operand (operands[1], i1)
      || !call_address_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern89 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !arith11_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern95 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_CCVmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CCVmode)
    return -1;
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern110 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_CCVmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CCVmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && input_operand (operands[1], E_QImode)
          && 
#line 1623 "../../gcc/config/sparc/sparc.md"
((register_operand (operands[0], QImode)
    || register_or_zero_operand (operands[1], QImode))))
        return 42; /* *movqi_insn */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && input_operand (operands[1], E_HImode)
          && 
#line 1645 "../../gcc/config/sparc/sparc.md"
((register_operand (operands[0], HImode)
    || register_or_zero_operand (operands[1], HImode))))
        return 43; /* *movhi_insn */
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && input_operand (operands[1], E_SImode)
          && 
#line 1676 "../../gcc/config/sparc/sparc.md"
(register_operand (operands[0], SImode)
   || register_or_zero_or_all_ones_operand (operands[1], SImode)))
        return 45; /* *movsi_insn */
      break;

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && input_operand (operands[1], E_DImode)
          && 
#line 1835 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32
   && (register_operand (operands[0], DImode)
       || register_or_zero_operand (operands[1], DImode))))
        return 53; /* *movdi_insn_sp32 */
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && input_operand (operands[1], E_SFmode)
          && 
#line 2370 "../../gcc/config/sparc/sparc.md"
((register_operand (operands[0], SFmode)
    || register_or_zero_or_all_ones_operand (operands[1], SFmode))))
        return 71; /* *movsf_insn */
      break;

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && input_operand (operands[1], E_DFmode)
          && 
#line 2464 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32
   && (register_operand (operands[0], DFmode)
       || register_or_zero_or_all_ones_operand (operands[1], DFmode))))
        return 74; /* *movdf_insn_sp32 */
      break;

    case E_TFmode:
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode)
          && 
#line 2639 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32
   && (register_operand (operands[0], TFmode)
       || register_or_zero_operand (operands[1], TFmode))))
        return 75; /* *movtf_insn_sp32 */
      break;

    case E_V1SImode:
      if (nonimmediate_operand (operands[0], E_V1SImode)
          && input_operand (operands[1], E_V1SImode)
          && 
#line 8445 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (register_operand (operands[0], V1SImode)
       || register_or_zero_or_all_ones_operand (operands[1], V1SImode))))
        return 310; /* *movv1si_insn */
      break;

    case E_V2HImode:
      if (nonimmediate_operand (operands[0], E_V2HImode)
          && input_operand (operands[1], E_V2HImode)
          && 
#line 8445 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (register_operand (operands[0], V2HImode)
       || register_or_zero_or_all_ones_operand (operands[1], V2HImode))))
        return 311; /* *movv2hi_insn */
      break;

    case E_V4QImode:
      if (nonimmediate_operand (operands[0], E_V4QImode)
          && input_operand (operands[1], E_V4QImode)
          && 
#line 8445 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (register_operand (operands[0], V4QImode)
       || register_or_zero_or_all_ones_operand (operands[1], V4QImode))))
        return 312; /* *movv4qi_insn */
      break;

    case E_V1DImode:
      if (nonimmediate_operand (operands[0], E_V1DImode)
          && input_operand (operands[1], E_V1DImode)
          && 
#line 8492 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH32
   && (register_operand (operands[0], V1DImode)
       || register_or_zero_or_all_ones_operand (operands[1], V1DImode))))
        return 313; /* *movv1di_insn_sp32 */
      break;

    case E_V2SImode:
      if (nonimmediate_operand (operands[0], E_V2SImode)
          && input_operand (operands[1], E_V2SImode)
          && 
#line 8492 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH32
   && (register_operand (operands[0], V2SImode)
       || register_or_zero_or_all_ones_operand (operands[1], V2SImode))))
        return 314; /* *movv2si_insn_sp32 */
      break;

    case E_V4HImode:
      if (nonimmediate_operand (operands[0], E_V4HImode)
          && input_operand (operands[1], E_V4HImode)
          && 
#line 8492 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH32
   && (register_operand (operands[0], V4HImode)
       || register_or_zero_or_all_ones_operand (operands[1], V4HImode))))
        return 315; /* *movv4hi_insn_sp32 */
      break;

    case E_V8QImode:
      if (nonimmediate_operand (operands[0], E_V8QImode)
          && input_operand (operands[1], E_V8QImode)
          && 
#line 8492 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH32
   && (register_operand (operands[0], V8QImode)
       || register_or_zero_or_all_ones_operand (operands[1], V8QImode))))
        return 316; /* *movv8qi_insn_sp32 */
      break;

    default:
      break;
    }
  operands[0] = x2;
  res = recog_5 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (pnum_clobbers == NULL
          || maybe_ne (SUBREG_BYTE (x2), 4)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != LSHIFTRT
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != SIGN_EXTEND
          || GET_MODE (x7) != E_DImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[3] = x10;
      if (!small_int_operand (operands[3], E_SImode)
          || !
#line 4795 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
        return -1;
      *pnum_clobbers = 1;
      return 150; /* *sparc.md:4787 */

    case MEM:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PLUS
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 19
          || GET_MODE (x5) != E_SImode)
        return -1;
      x11 = XVECEXP (x5, 0, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x12 = XVECEXP (x5, 0, 1);
      operands[3] = x12;
      if (!tld_symbolic_operand (operands[3], E_VOIDmode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          return 296; /* *tldo_ldubsi */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          return 301; /* *tldo_lduhsi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          return 304; /* *tldo_lduwsi */

        default:
          return -1;
        }

    case REG:
      if (pnum_clobbers == NULL
          || REGNO (x2) != 102
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || !
#line 8839 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH32))
        return -1;
      *pnum_clobbers = 1;
      return 422; /* rdgsr_v8plus */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FIX:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern50 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 3662 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 109; /* fix_truncsfsi2 */

            case 1:
              if (!
#line 3670 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 110; /* fix_truncdfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern50 (x3, 
E_DImode))
            {
            case 0:
              if (!
#line 3700 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 112; /* fix_truncsfdi2 */

            case 1:
              if (!
#line 3714 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 113; /* fix_truncdfdi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 3685 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 111; /* *fix_trunctfsi2_hq */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !
#line 3734 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 114; /* *fix_trunctfdi2_hq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case ZERO_EXTEND:
      return recog_23 (x1, insn, pnum_clobbers);

    case AND:
    case IOR:
    case XOR:
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_MODE (x8) != E_CCmode
          || GET_MODE (x5) != E_CCmode
          || !register_operand (operands[0], E_SImode))
        return -1;
      switch (GET_CODE (x6))
        {
        case AND:
        case IOR:
          res = recog_22 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      x9 = XEXP (x2, 1);
      if (!cc_arith_operator (x9, E_SImode))
        return -1;
      operands[4] = x9;
      operands[3] = x6;
      if (!cc_arith_operator (operands[3], E_SImode))
        return -1;
      x10 = XEXP (x6, 0);
      operands[1] = x10;
      if (!arith_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x6, 1);
      operands[2] = x11;
      if (!arith_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XEXP (x9, 1);
      if (!rtx_equal_p (x13, operands[2])
          || !
#line 5544 "../../gcc/config/sparc/sparc.md"
(GET_CODE (operands[3]) == GET_CODE (operands[4])))
        return -1;
      return 179; /* *cmp_cc_arith_op_set */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      if (GET_CODE (x6) == SUBREG
          && known_eq (SUBREG_BYTE (x6), 3)
          && GET_MODE (x6) == E_QImode)
        {
          x7 = XEXP (x5, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x9 = XEXP (x2, 1);
              if (GET_CODE (x9) == SUBREG
                  && known_eq (SUBREG_BYTE (x9), 3)
                  && GET_MODE (x9) == E_QImode
                  && pattern97 (x1, 
E_QImode, 
E_CCmode) == 0)
                return 92; /* *cmp_siqi_trunc_set */
            }
        }
      operands[1] = x6;
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != MINUS)
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XEXP (x9, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_MODE (x8))
        {
        case E_CCCmode:
          if (GET_MODE (x5) != E_CCCmode
              || !register_operand (operands[1], E_DImode)
              || !arith_double_operand (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x9) != E_DImode)
            return -1;
          return 130; /* usubvdi4_sp32 */

        case E_CCmode:
          if (GET_MODE (x5) != E_CCmode
              || !register_or_zero_operand (operands[1], E_SImode)
              || !arith_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x9) != E_SImode)
            return -1;
          return 137; /* *cmpsi_set */

        default:
          return -1;
        }

    case PLUS:
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x6, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          x11 = XEXP (x6, 1);
          operands[2] = x11;
          x12 = XEXP (x9, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x9, 1);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x7 = XEXP (x5, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x7, operands[1]))
                return -1;
              x8 = XEXP (x4, 0);
              if (GET_MODE (x8) != E_CCCmode
                  || GET_MODE (x5) != E_CCCmode)
                return -1;
              switch (GET_MODE (x6))
                {
                case E_DImode:
                  if (!register_operand (operands[1], E_DImode)
                      || !arith_double_operand (operands[2], E_DImode)
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  return 116; /* uaddvdi4_sp32 */

                case E_SImode:
                  if (pattern102 (x9) != 0)
                    return -1;
                  return 124; /* *cmp_ccc_plus_set */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x7, 0) != 2
                  || XINT (x7, 1) != 62
                  || pattern100 (x4) != 0)
                return -1;
              switch (GET_MODE (x6))
                {
                case E_DImode:
                  if (pattern107 (x1) != 0)
                    return -1;
                  return 117; /* addvdi4_sp32 */

                case E_SImode:
                  if (!register_operand (operands[1], E_SImode)
                      || pattern108 (x1) != 0)
                    return -1;
                  return 127; /* *cmp_ccv_plus_set */

                default:
                  return -1;
                }

            case CONST_INT:
              if (pattern91 (x4) != 0
                  || pattern102 (x9) != 0)
                return -1;
              return 122; /* *cmp_ccnz_plus_set */

            default:
              return -1;
            }

        case PLUS:
          if (pattern84 (x5, 
E_CCCmode, 
PLUS, 
62) != 0
              || pattern109 (x9, 
E_CCCmode, 
PLUS) != 0
              || pattern110 (x4) != 0)
            return -1;
          x14 = XEXP (x10, 1);
          operands[2] = x14;
          if (!arith_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x9) != E_SImode
              || pattern112 (x1) != 0)
            return -1;
          return 128; /* *cmp_ccv_plus_sltu_set */

        default:
          return -1;
        }

    case MINUS:
      x10 = XEXP (x6, 0);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x10;
          x11 = XEXP (x6, 1);
          operands[2] = x11;
          x7 = XEXP (x5, 1);
          switch (GET_CODE (x7))
            {
            case UNSPEC:
              if (XVECLEN (x7, 0) != 2
                  || XINT (x7, 1) != 63)
                return -1;
              x9 = XEXP (x2, 1);
              if (GET_CODE (x9) != MINUS)
                return -1;
              x8 = XEXP (x4, 0);
              if (GET_MODE (x8) != E_CCVmode
                  || GET_MODE (x5) != E_CCVmode
                  || pattern101 (x1) != 0)
                return -1;
              switch (GET_MODE (x6))
                {
                case E_DImode:
                  if (pattern107 (x1) != 0)
                    return -1;
                  return 131; /* subvdi4_sp32 */

                case E_SImode:
                  if (!register_or_zero_operand (operands[1], E_SImode)
                      || pattern108 (x1) != 0)
                    return -1;
                  return 140; /* *cmp_ccv_minus_set */

                default:
                  return -1;
                }

            case CONST_INT:
              if (pattern91 (x4) != 0
                  || !register_or_zero_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_SImode))
                return -1;
              x9 = XEXP (x2, 1);
              if (GET_MODE (x9) != E_SImode)
                return -1;
              switch (GET_CODE (x9))
                {
                case MINUS:
                  if (!arith_operand (operands[2], E_SImode))
                    return -1;
                  x12 = XEXP (x9, 0);
                  if (!rtx_equal_p (x12, operands[1]))
                    return -1;
                  x13 = XEXP (x9, 1);
                  if (!rtx_equal_p (x13, operands[2]))
                    return -1;
                  return 136; /* *cmp_ccnz_minus_set */

                case UNSPEC:
                  if (XVECLEN (x9, 0) != 2
                      || !register_or_zero_operand (operands[2], E_SImode))
                    return -1;
                  x15 = XVECEXP (x9, 0, 0);
                  if (!rtx_equal_p (x15, operands[1]))
                    return -1;
                  x16 = XVECEXP (x9, 0, 1);
                  if (!rtx_equal_p (x16, operands[2]))
                    return -1;
                  switch (XINT (x9, 1))
                    {
                    case 33:
                      if (!(
#line 8926 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 432; /* edge8si_vis */

                    case 34:
                      if (!(
#line 8937 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 433; /* edge8lsi_vis */

                    case 35:
                      if (!(
#line 8948 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 434; /* edge16si_vis */

                    case 36:
                      if (!(
#line 8959 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 435; /* edge16lsi_vis */

                    case 37:
                      if (!(
#line 8970 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 436; /* edge32si_vis */

                    case 38:
                      if (!(
#line 8981 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 437; /* edge32lsi_vis */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          if (pattern84 (x5, 
E_CCmode, 
MINUS, 
63) != 0)
            return -1;
          x9 = XEXP (x2, 1);
          if (GET_CODE (x9) != MINUS
              || GET_MODE (x9) != E_SImode
              || pattern109 (x9, 
E_CCmode, 
MINUS) != 0
              || pattern99 (x4, 
E_CCVmode) != 0
              || pattern112 (x1) != 0)
            return -1;
          return 141; /* *cmp_ccv_minus_sltu_set */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != MULT
          || GET_MODE (x9) != E_SImode)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_MODE (x8) != E_CCmode
          || GET_MODE (x5) != E_CCmode)
        return -1;
      x10 = XEXP (x6, 0);
      operands[1] = x10;
      if (!arith_operand (operands[1], E_SImode)
          || pattern77 (x1) != 0
          || !
#line 4633 "../../gcc/config/sparc/sparc.md"
(TARGET_V8 || TARGET_SPARCLITE || TARGET_DEPRECATED_V8_INSNS))
        return -1;
      return 144; /* *cmp_mul_set */

    case DIV:
      if (pnum_clobbers == NULL
          || pattern78 (x1, 
DIV) != 0
          || !
#line 5240 "../../gcc/config/sparc/sparc.md"
(TARGET_V8 || TARGET_DEPRECATED_V8_INSNS))
        return -1;
      *pnum_clobbers = 1;
      return 166; /* *cmp_sdiv_cc_set */

    case UDIV:
      if (pattern78 (x1, 
UDIV) != 0
          || !
#line 5329 "../../gcc/config/sparc/sparc.md"
(TARGET_V8 || TARGET_DEPRECATED_V8_INSNS))
        return -1;
      return 168; /* *cmp_udiv_cc_set */

    case NOT:
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x10 = XEXP (x6, 0);
      switch (GET_CODE (x10))
        {
        case XOR:
          if (GET_MODE (x10) != E_SImode
              || XWINT (x7, 0) != 0L)
            return -1;
          x9 = XEXP (x2, 1);
          if (GET_CODE (x9) != NOT
              || GET_MODE (x9) != E_SImode)
            return -1;
          x12 = XEXP (x9, 0);
          if (GET_CODE (x12) != XOR
              || GET_MODE (x12) != E_SImode
              || pattern99 (x4, 
E_CCmode) != 0)
            return -1;
          x17 = XEXP (x12, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          x18 = XEXP (x12, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          return 181; /* *cmp_cc_xor_not_set */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x10;
          switch (XWINT (x7, 0))
            {
            case -1L:
              x9 = XEXP (x2, 1);
              if (GET_CODE (x9) != NEG)
                return -1;
              x8 = XEXP (x4, 0);
              if (GET_MODE (x8) != E_CCCmode
                  || GET_MODE (x5) != E_CCCmode)
                return -1;
              x12 = XEXP (x9, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              switch (GET_MODE (x6))
                {
                case E_DImode:
                  if (!register_operand (operands[1], E_DImode)
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  return 185; /* unegvdi3_sp32 */

                case E_SImode:
                  if (!register_operand (operands[1], E_SImode)
                      || !register_operand (operands[0], E_SImode)
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  return 190; /* *cmp_ccc_neg_set */

                default:
                  return -1;
                }

            case 0L:
              x9 = XEXP (x2, 1);
              if (GET_CODE (x9) != NOT
                  || GET_MODE (x9) != E_SImode)
                return -1;
              x8 = XEXP (x4, 0);
              if (GET_MODE (x8) != E_CCmode
                  || GET_MODE (x5) != E_CCmode
                  || GET_MODE (x6) != E_SImode
                  || !arith_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_SImode))
                return -1;
              x12 = XEXP (x9, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              return 197; /* *cmp_cc_set_not */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != NEG)
        return -1;
      x10 = XEXP (x6, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          x12 = XEXP (x9, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x7 = XEXP (x5, 1);
          switch (GET_CODE (x7))
            {
            case UNSPEC:
              if (XVECLEN (x7, 0) != 1
                  || XINT (x7, 1) != 64)
                return -1;
              x8 = XEXP (x4, 0);
              if (GET_MODE (x8) != E_CCVmode
                  || GET_MODE (x5) != E_CCVmode)
                return -1;
              x19 = XVECEXP (x7, 0, 0);
              if (!rtx_equal_p (x19, operands[1]))
                return -1;
              switch (GET_MODE (x6))
                {
                case E_DImode:
                  if (pattern103 (x1, 
E_DImode) != 0)
                    return -1;
                  return 186; /* negvdi3_sp32 */

                case E_SImode:
                  if (pattern103 (x1, 
E_SImode) != 0)
                    return -1;
                  return 193; /* *cmp_ccv_neg_set */

                default:
                  return -1;
                }

            case CONST_INT:
              if (pattern91 (x4) != 0
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x9) != E_SImode)
                return -1;
              return 189; /* *cmp_ccnz_neg_set */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          x14 = XEXP (x10, 1);
          if (GET_CODE (x14) != LTU
              || GET_MODE (x14) != E_SImode)
            return -1;
          x20 = XEXP (x14, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 100
              || GET_MODE (x20) != E_CCCmode)
            return -1;
          x21 = XEXP (x14, 1);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 1);
          if (pattern88 (x7, 
E_SImode, 
64, 
1) != 0)
            return -1;
          x19 = XVECEXP (x7, 0, 0);
          if (GET_CODE (x19) != PLUS
              || GET_MODE (x19) != E_SImode)
            return -1;
          x22 = XEXP (x19, 1);
          if (GET_CODE (x22) != LTU
              || GET_MODE (x22) != E_SImode)
            return -1;
          x23 = XEXP (x22, 0);
          if (GET_CODE (x23) != REG
              || REGNO (x23) != 100
              || GET_MODE (x23) != E_CCCmode)
            return -1;
          x24 = XEXP (x22, 1);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XEXP (x9, 0);
          if (GET_CODE (x12) != PLUS
              || GET_MODE (x12) != E_SImode)
            return -1;
          x18 = XEXP (x12, 1);
          if (GET_CODE (x18) != LTU
              || GET_MODE (x18) != E_SImode)
            return -1;
          x25 = XEXP (x18, 0);
          if (GET_CODE (x25) != REG
              || REGNO (x25) != 100
              || GET_MODE (x25) != E_CCCmode)
            return -1;
          x26 = XEXP (x18, 1);
          if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern110 (x4) != 0
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x9) != E_SImode)
            return -1;
          x27 = XEXP (x19, 0);
          if (!rtx_equal_p (x27, operands[1]))
            return -1;
          x17 = XEXP (x12, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          return 194; /* *cmp_ccv_neg_sltu_set */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x6, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != ASHIFT
          || GET_MODE (x9) != E_SImode)
        return -1;
      x13 = XEXP (x9, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern97 (x1, 
E_SImode, 
E_CCNZmode) != 0)
        return -1;
      return 239; /* *cmp_ccnz_set_ashift_1 */

    default:
      return -1;
    }
}
