/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern4 (x3, 
E_V4HImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern4 (x3, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern4 (x3, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V1SImode:
      if (pattern4 (x3, 
E_V1SImode) != 0)
        return -1;
      return 3;

    case E_V8QImode:
      if (pattern4 (x3, 
E_V8QImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  return 0;
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case NE:
      return pattern27 (x6); /* [-1, 0] */

    case EQ:
      if (pattern27 (x6) != 0)
        return -1;
      return 1;

    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 2
      || XINT (x4, 1) != 19
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  operands[3] = x6;
  if (!tld_symbolic_operand (operands[3], E_VOIDmode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 1;

        case E_HImode:
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!symbolic_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fcc_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !register_operand (operands[2], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !register_operand (operands[2], E_DFmode))
        return -1;
      return 1;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !register_operand (operands[2], E_TFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (x1))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode)
          || !register_operand (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode)
          || !register_operand (operands[2], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode)
          || !register_operand (operands[2], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_or_zero_operand (operands[1], i1)
      || !register_or_zero_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
      if (pattern40 (x3, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 13; /* *plus_snesisi_zero */

    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case NE:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 14; /* *plus_plus_snesisi_zero */

        case LTU:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 0);
          operands[3] = x7;
          if (!icc_register_operand (operands[3], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          if (!arith_operand (operands[2], E_SImode)
              || !
#line 1125 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode))
            return -1;
          return 21; /* *plus_plus_sltusi */

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x3, 1);
          if (GET_CODE (x9) != LTU
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!arith_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[3] = x11;
          if (!icc_register_operand (operands[3], E_VOIDmode)
              || !
#line 1161 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode))
            return -1;
          return 24; /* *addxsi */

        default:
          return -1;
        }

    case EQ:
      if (pattern40 (x3, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 17; /* *plus_seqsisi_zero */

    case LTU:
      if (pattern41 (x3) != 0)
        return -1;
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      if (!arith_operand (operands[1], E_SImode)
          || !
#line 1115 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
        return -1;
      return 20; /* *plus_sltusi */

    case GEU:
      if (pattern41 (x3) != 0)
        return -1;
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1271 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
        return -1;
      return 31; /* *plus_sgeusi */

    case REG:
    case SUBREG:
      operands[1] = x4;
      x9 = XEXP (x3, 1);
      switch (GET_CODE (x9))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x9;
          switch (pattern72 (x3, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 115; /* adddi3_sp32 */

            case 1:
              return 120; /* addsi3 */

            case 2:
              if (!
#line 6026 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 199; /* *addtf3_hq */

            case 3:
              if (!
#line 6034 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 200; /* adddf3 */

            case 4:
              if (!
#line 6043 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 201; /* addsf3 */

            case 5:
              if (!
#line 8588 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 317; /* addv1si3 */

            case 6:
              if (!
#line 8588 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 319; /* addv2si3 */

            case 7:
              if (!
#line 8588 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 321; /* addv2hi3 */

            case 8:
              if (!
#line 8588 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 323; /* addv4hi3 */

            case 9:
              if (!
#line 9271 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B))
                return -1;
              return 484; /* fpadd64_vis */

            case 10:
              if (!
#line 9280 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
                return -1;
              return 486; /* addv8qi3 */

            default:
              return -1;
            }

        case UNSPEC:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x9) != E_SImode)
            return -1;
          switch (XVECLEN (x9, 0))
            {
            case 2:
              x12 = XVECEXP (x9, 0, 0);
              operands[2] = x12;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              x13 = XVECEXP (x9, 0, 1);
              operands[3] = x13;
              switch (XINT (x9, 1))
                {
                case 17:
                  if (!tgd_symbolic_operand (operands[3], E_VOIDmode))
                    return -1;
                  return 282; /* tgd_addsi */

                case 19:
                  if (!tld_symbolic_operand (operands[3], E_VOIDmode))
                    return -1;
                  return 290; /* tldo_addsi */

                default:
                  return -1;
                }

            case 1:
              if (XINT (x9, 1) != 18)
                return -1;
              x12 = XVECEXP (x9, 0, 0);
              operands[2] = x12;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              return 286; /* tldm_addsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_DImode
          || pattern39 (x3, 
E_DImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 119; /* *adddi3_extend_sp32 */

    case MULT:
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!arith_operand (operands[2], E_SImode)
              || !register_operand (operands[3], E_SImode)
              || !
#line 5351 "../../gcc/config/sparc/sparc.md"
(TARGET_SPARCLET))
            return -1;
          return 169; /* *smacsi */

        case SIGN_EXTEND:
          if (pattern60 (x3, 
SIGN_EXTEND) != 0
              || !
#line 5362 "../../gcc/config/sparc/sparc.md"
(TARGET_SPARCLET))
            return -1;
          return 170; /* *smacdi */

        case ZERO_EXTEND:
          if (pattern60 (x3, 
ZERO_EXTEND) != 0
              || !
#line 5373 "../../gcc/config/sparc/sparc.md"
(TARGET_SPARCLET))
            return -1;
          return 171; /* *umacdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (address_operand (operands[1], E_SImode))
        {
          *pnum_clobbers = 1;
          return 253; /* *call_value_addresssi */
        }
      if (!symbolic_operand (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 254; /* *call_value_symbolicsi */

    case UNSPEC:
      if (!register_operand (operands[0], E_VOIDmode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          if (XINT (x5, 1) != 17)
            return -1;
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          if (!symbolic_operand (operands[1], E_SImode))
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          operands[2] = x8;
          if (!tgd_symbolic_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          *pnum_clobbers = 1;
          return 283; /* tgd_callsi */

        case 1:
          if (XINT (x5, 1) != 18)
            return -1;
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          if (!symbolic_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          *pnum_clobbers = 1;
          return 287; /* tldm_callsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case NE:
      if (pattern65 (x1) != 0)
        return -1;
      return 13; /* *plus_snesisi_zero */

    case PLUS:
      if (pattern66 (x5) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern32 (x6, 
E_CCmode, 
100) != 0
          || pattern96 (x4) != 0)
        return -1;
      return 14; /* *plus_plus_snesisi_zero */

    case EQ:
      if (pattern65 (x1) != 0)
        return -1;
      return 17; /* *plus_seqsisi_zero */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x5;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x8 = XEXP (x6, 0);
          if (pattern79 (x8, 
E_DImode, 
E_CCmode, 
100) != 0
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !arith_double_operand (operands[2], E_DImode))
            return -1;
          return 115; /* adddi3_sp32 */

        case SET:
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != ZERO_EXTRACT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 102
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x8, 1);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x11 = XEXP (x8, 2);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          x12 = XEXP (x6, 1);
          if (GET_MODE (x12) != E_DImode)
            return -1;
          switch (GET_CODE (x12))
            {
            case ZERO_EXTEND:
              x13 = XEXP (x12, 0);
              if (GET_CODE (x13) != PLUS
                  || GET_MODE (x13) != E_SImode
                  || pattern104 (x1, 
E_SImode) != 0)
                return -1;
              switch (XWINT (x10, 0))
                {
                case 3L:
                  if (XWINT (x11, 0) != 0L
                      || !
#line 8866 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                    return -1;
                  return 427; /* alignaddrsi_vis */

                case 32L:
                  if (XWINT (x11, 0) != 32L
                      || !
#line 9095 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                    return -1;
                  return 459; /* bmasksi_vis */

                default:
                  return -1;
                }

            case PLUS:
              if (XWINT (x10, 0) != 3L
                  || XWINT (x11, 0) != 0L
                  || pattern105 (x4, 
E_DImode) != 0)
                return -1;
              x13 = XEXP (x12, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x14 = XEXP (x12, 1);
              if (!rtx_equal_p (x14, operands[2])
                  || !
#line 8877 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 428; /* alignaddrdi_vis */

            case XOR:
              x14 = XEXP (x12, 1);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
                  || XWINT (x10, 0) != 3L
                  || XWINT (x11, 0) != 0L)
                return -1;
              x13 = XEXP (x12, 0);
              if (GET_MODE (x13) != E_DImode)
                return -1;
              switch (GET_CODE (x13))
                {
                case ZERO_EXTEND:
                  x15 = XEXP (x13, 0);
                  if (GET_CODE (x15) != PLUS
                      || GET_MODE (x15) != E_SImode
                      || pattern105 (x4, 
E_SImode) != 0)
                    return -1;
                  x16 = XEXP (x15, 0);
                  if (!rtx_equal_p (x16, operands[1]))
                    return -1;
                  x17 = XEXP (x15, 1);
                  if (!rtx_equal_p (x17, operands[2])
                      || !
#line 8889 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                    return -1;
                  return 429; /* alignaddrlsi_vis */

                case PLUS:
                  if (pattern104 (x1, 
E_DImode) != 0
                      || !
#line 8901 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                    return -1;
                  return 430; /* alignaddrldi_vis */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode
          || pattern64 (x1, 
E_DImode) != 0)
        return -1;
      return 119; /* *adddi3_extend_sp32 */

    default:
      return -1;
    }
}
