/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (pnum_clobbers == NULL
          || XWINT (x5, 0) != 0L
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      res = pattern0 (x5);
      if (res >= 0)
        return res + 1; /* [1, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  return 0;
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!const_compl_high_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SImode:
      return pattern46 (x1, 
E_V1SImode); /* [-1, 0] */

    case E_V2HImode:
      if (pattern46 (x1, 
E_V2HImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern46 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V1DImode:
      if (pattern46 (x1, 
E_V1DImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern46 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4HImode:
      if (pattern46 (x1, 
E_V4HImode) != 0)
        return -1;
      return 5;

    case E_V8QImode:
      if (pattern46 (x1, 
E_V8QImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  if (!symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern67 (rtx x1, rtx_code i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x7, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  return 0;
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_DImode)
      || !arith_double_operand (operands[2], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case MEM:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != PLUS
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 19
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      operands[3] = x6;
      if (!tld_symbolic_operand (operands[3], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode))
            return -1;
          return 305; /* *tldo_stbsi */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode))
            return -1;
          return 306; /* *tldo_sthsi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          return 307; /* *tldo_stwsi */

        default:
          return -1;
        }

    case REG:
      if (pnum_clobbers == NULL
          || REGNO (x2) != 102
          || GET_MODE (x2) != E_DImode
          || !arith_operand (operands[0], E_DImode)
          || !
#line 8807 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH32))
        return -1;
      *pnum_clobbers = 1;
      return 421; /* wrgsr_v8plus */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_DImode
                  || GET_MODE (x6) != E_DImode)
                return -1;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x6, 1);
              switch (GET_CODE (x9))
                {
                case SIGN_EXTEND:
                  if (pnum_clobbers != NULL
                      && GET_MODE (x9) == E_DImode)
                    {
                      x10 = XEXP (x9, 0);
                      operands[2] = x10;
                      if (register_operand (operands[2], E_SImode))
                        {
                          operands[3] = x5;
                          if (small_int_operand (operands[3], E_SImode)
                              && 
#line 4779 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                            {
                              *pnum_clobbers = 1;
                              return 149; /* smulsi3_highpart_v8plus */
                            }
                        }
                    }
                  if (GET_MODE (x9) != E_DImode
                      || XWINT (x5, 0) != 32L)
                    return -1;
                  x10 = XEXP (x9, 0);
                  operands[2] = x10;
                  if (!register_operand (operands[2], E_SImode)
                      || !
#line 4824 "../../gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
                    return -1;
                  return 152; /* *smulsi3_highpart_sp32 */

                case CONST_INT:
                  if (pnum_clobbers != NULL)
                    {
                      operands[2] = x9;
                      if (small_int_operand (operands[2], E_DImode))
                        {
                          operands[3] = x5;
                          if (small_int_operand (operands[3], E_SImode)
                              && 
#line 4810 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                            {
                              *pnum_clobbers = 1;
                              return 151; /* const_smulsi3_highpart_v8plus */
                            }
                        }
                    }
                  operands[2] = x9;
                  if (!small_int_operand (operands[2], E_DImode)
                      || XWINT (x5, 0) != 32L
                      || !
#line 4836 "../../gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
                    return -1;
                  return 153; /* const_smulsi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              x9 = XEXP (x6, 1);
              switch (GET_CODE (x9))
                {
                case ZERO_EXTEND:
                  if (pnum_clobbers != NULL
                      && GET_MODE (x9) == E_DImode
                      && pattern86 (x3, 
E_DImode, 
E_SImode) == 0
                      && register_operand (operands[1], E_SImode))
                    {
                      x10 = XEXP (x9, 0);
                      operands[2] = x10;
                      if (register_operand (operands[2], E_SImode))
                        {
                          operands[3] = x5;
                          if (small_int_operand (operands[3], E_SImode)
                              && 
#line 4981 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                            {
                              *pnum_clobbers = 1;
                              return 158; /* umulsi3_highpart_v8plus */
                            }
                        }
                    }
                  x10 = XEXP (x9, 0);
                  operands[2] = x10;
                  switch (XWINT (x5, 0))
                    {
                    case 32L:
                      if (pattern87 (x3) != 0
                          || GET_MODE (x9) != E_DImode
                          || !register_operand (operands[2], E_SImode)
                          || !
#line 5010 "../../gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
                        return -1;
                      return 160; /* *umulsi3_highpart_sp32 */

                    case 64L:
                      if (pnum_clobbers == NULL
                          || pattern86 (x3, 
E_TImode, 
E_DImode) != 0
                          || !arith_operand (operands[1], E_DImode)
                          || GET_MODE (x9) != E_TImode
                          || !arith_operand (operands[2], E_DImode)
                          || !
#line 5064 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
                        return -1;
                      *pnum_clobbers = 2;
                      return 162; /* umulxhi_v8plus */

                    default:
                      return -1;
                    }

                case CONST_INT:
                  if (pnum_clobbers != NULL)
                    {
                      operands[2] = x9;
                      if (uns_small_int_operand (operands[2], E_DImode)
                          && pattern87 (x3) == 0)
                        {
                          operands[3] = x5;
                          if (small_int_operand (operands[3], E_SImode)
                              && 
#line 4996 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                            {
                              *pnum_clobbers = 1;
                              return 159; /* const_umulsi3_highpart_v8plus */
                            }
                        }
                    }
                  operands[2] = x9;
                  if (!uns_small_int_operand (operands[2], E_DImode)
                      || XWINT (x5, 0) != 32L
                      || pattern87 (x3) != 0
                      || !
#line 5022 "../../gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
                    return -1;
                  return 161; /* const_umulsi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (pnum_clobbers == NULL
              || XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 58
              || GET_MODE (x6) != E_TImode)
            return -1;
          x11 = XVECEXP (x6, 0, 0);
          if (GET_CODE (x11) != ZERO_EXTEND
              || GET_MODE (x11) != E_TImode)
            return -1;
          x12 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x12) != ZERO_EXTEND
              || GET_MODE (x12) != E_TImode
              || XWINT (x5, 0) != 64L
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_TImode)
            return -1;
          x13 = XEXP (x11, 0);
          operands[1] = x13;
          if (!arith_operand (operands[1], E_DImode))
            return -1;
          x14 = XEXP (x12, 0);
          operands[2] = x14;
          if (!arith_operand (operands[2], E_DImode)
              || !
#line 5150 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 2;
          return 164; /* xmulxhi_v8plus */

        case PLUS:
          if (GET_MODE (x6) != E_V4SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != PLUS
              || GET_MODE (x7) != E_V4SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != ZERO_EXTEND
              || GET_MODE (x8) != E_V4SImode)
            return -1;
          x15 = XEXP (x7, 1);
          if (GET_CODE (x15) != ZERO_EXTEND
              || GET_MODE (x15) != E_V4SImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != CONST_VECTOR
              || XVECLEN (x9, 0) != 4
              || GET_MODE (x9) != E_V4SImode)
            return -1;
          x16 = XVECEXP (x9, 0, 0);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x17 = XVECEXP (x9, 0, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x18 = XVECEXP (x9, 0, 2);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x19 = XVECEXP (x9, 0, 3);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x5, 0) != 1L
              || !register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || GET_MODE (x4) != E_V4SImode)
            return -1;
          x20 = XEXP (x8, 0);
          operands[1] = x20;
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          x21 = XEXP (x15, 0);
          operands[2] = x21;
          if (!register_operand (operands[2], E_V4HImode)
              || !
#line 9262 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 483; /* fmean16_vis */

        default:
          return -1;
        }

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 58
          || GET_MODE (x4) != E_TImode)
        return -1;
      x22 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x22) != ZERO_EXTEND
          || GET_MODE (x22) != E_TImode)
        return -1;
      x23 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x23) != ZERO_EXTEND
          || GET_MODE (x23) != E_TImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x24 = XEXP (x22, 0);
      operands[1] = x24;
      if (!arith_operand (operands[1], E_DImode))
        return -1;
      x25 = XEXP (x23, 0);
      operands[2] = x25;
      if (!arith_operand (operands[2], E_DImode)
          || !
#line 5104 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
        return -1;
      *pnum_clobbers = 2;
      return 163; /* xmulx_v8plus */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 8)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x5, 0, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern98 (x5, 
E_SImode) != 0)
        return -1;
      if (
#line 216 "../../gcc/config/sparc/sync.md"
(TARGET_V9 && (SImode != DImode || TARGET_ARCH64)))
        return 559; /* *atomic_compare_and_swapsi_1 */
      if (!
#line 228 "../../gcc/config/sparc/sync.md"
(TARGET_LEON3))
        return -1;
      return 560; /* atomic_compare_and_swap_leon3_1 */

    case E_DImode:
      if (pattern98 (x5, 
E_DImode) != 0
          || !
#line 249 "../../gcc/config/sparc/sync.md"
(TARGET_V8PLUS))
        return -1;
      return 561; /* *atomic_compare_and_swapdi_v8plus */

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case NE:
          if (pattern26 (x1) != 0)
            return NULL;
          return gen_split_1 (insn, operands);

        case NEG:
          switch (pattern28 (x1))
            {
            case 0:
              return gen_split_2 (insn, operands);

            case 1:
              return gen_split_4 (insn, operands);

            case 2:
              if (!(
#line 5714 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 5716 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_48 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          if (pattern26 (x1) != 0)
            return NULL;
          return gen_split_3 (insn, operands);

        case PLUS:
          x4 = XVECEXP (x1, 0, 1);
          if (pattern32 (x4, 
E_CCmode, 
100) != 0)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case NE:
              if (pattern85 (x3) != 0)
                return NULL;
              return gen_split_5 (insn, operands);

            case PLUS:
              if (pattern66 (x6) != 0
                  || pattern96 (x3) != 0)
                return NULL;
              return gen_split_6 (insn, operands);

            case EQ:
              if (pattern85 (x3) != 0)
                return NULL;
              return gen_split_9 (insn, operands);

            case REG:
            case SUBREG:
              operands[1] = x6;
              if (!register_operand (operands[1], E_DImode)
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              if (!arith_double_operand (operands[2], E_DImode)
                  || !(
#line 3816 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3818 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_34 (insn, operands);

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_DImode
                  || pattern63 (x3, 
E_DImode) != 0
                  || !(
#line 3932 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3934 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_38 (insn, operands);

            default:
              return NULL;
            }

        case MINUS:
          switch (pattern34 (x1))
            {
            case 0:
              return gen_split_7 (insn, operands);

            case 1:
              return gen_split_10 (insn, operands);

            case 2:
              if (!(
#line 4232 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4234 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_39 (insn, operands);

            case 3:
              if (!(
#line 4347 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4349 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_43 (insn, operands);

            case 4:
              return gen_split_8 (insn, operands);

            default:
              return NULL;
            }

        case COMPARE:
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 100)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return NULL;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_DImode))
            return NULL;
          x9 = XEXP (x4, 1);
          if (GET_MODE (x9) != E_DImode)
            return NULL;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case PLUS:
              if (GET_MODE (x6) != E_DImode
                  || GET_CODE (x9) != PLUS)
                return NULL;
              x10 = XEXP (x6, 0);
              operands[1] = x10;
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              x11 = XEXP (x6, 1);
              operands[2] = x11;
              if (!arith_double_operand (operands[2], E_DImode))
                return NULL;
              x12 = XEXP (x9, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return NULL;
              x13 = XEXP (x9, 1);
              if (!rtx_equal_p (x13, operands[2]))
                return NULL;
              x7 = XEXP (x3, 1);
              switch (GET_CODE (x7))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x7, operands[1])
                      || GET_MODE (x5) != E_CCCmode
                      || GET_MODE (x3) != E_CCCmode
                      || !(
#line 3844 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3846 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                    return NULL;
                  return gen_split_35 (insn, operands);

                case UNSPEC:
                  if (XVECLEN (x7, 0) != 2
                      || XINT (x7, 1) != 62
                      || GET_MODE (x7) != E_DImode
                      || pattern100 (x2) != 0
                      || !(
#line 3882 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3884 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                    return NULL;
                  return gen_split_36 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              operands[1] = x6;
              if (!register_operand (operands[1], E_DImode)
                  || GET_CODE (x9) != MINUS
                  || GET_MODE (x5) != E_CCCmode
                  || GET_MODE (x3) != E_CCCmode)
                return NULL;
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              if (!arith_double_operand (operands[2], E_DImode))
                return NULL;
              x12 = XEXP (x9, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return NULL;
              x13 = XEXP (x9, 1);
              if (!rtx_equal_p (x13, operands[2])
                  || !(
#line 4258 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4260 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_40 (insn, operands);

            case MINUS:
              if (GET_MODE (x6) != E_DImode)
                return NULL;
              x7 = XEXP (x3, 1);
              if (pattern88 (x7, 
E_DImode, 
63, 
2) != 0
                  || GET_CODE (x9) != MINUS
                  || GET_MODE (x5) != E_CCVmode
                  || GET_MODE (x3) != E_CCVmode)
                return NULL;
              x10 = XEXP (x6, 0);
              operands[1] = x10;
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              x11 = XEXP (x6, 1);
              operands[2] = x11;
              if (!arith_double_operand (operands[2], E_DImode)
                  || pattern101 (x1) != 0
                  || !(
#line 4298 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4300 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_41 (insn, operands);

            case NOT:
              if (GET_MODE (x6) != E_DImode)
                return NULL;
              x7 = XEXP (x3, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
                  || pattern92 (x1, 
E_CCCmode) != 0)
                return NULL;
              x12 = XEXP (x9, 0);
              if (!rtx_equal_p (x12, operands[1])
                  || !(
#line 5734 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 5736 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_49 (insn, operands);

            case NEG:
              if (GET_MODE (x6) != E_DImode)
                return NULL;
              x7 = XEXP (x3, 1);
              if (pattern88 (x7, 
E_DImode, 
64, 
1) != 0
                  || pattern92 (x1, 
E_CCVmode) != 0)
                return NULL;
              x14 = XVECEXP (x7, 0, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return NULL;
              x12 = XEXP (x9, 0);
              if (!rtx_equal_p (x12, operands[1])
                  || !(
#line 5763 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 5765 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_50 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          if (pattern35 (x1) != 0)
            return NULL;
          return gen_split_44 (insn, operands);

        case IOR:
          if (pattern35 (x1) != 0)
            return NULL;
          return gen_split_45 (insn, operands);

        case XOR:
          if (pattern35 (x1) != 0)
            return NULL;
          return gen_split_46 (insn, operands);

        case NOT:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != XOR
              || GET_MODE (x6) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x10 = XEXP (x6, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x11 = XEXP (x6, 1);
          operands[2] = x11;
          if (!const_compl_high_operand (operands[2], E_SImode))
            return NULL;
          x8 = XEXP (x4, 0);
          operands[3] = x8;
          if (!register_operand (operands[3], E_SImode))
            return NULL;
          return gen_split_47 (insn, operands);

        default:
          return NULL;
        }

    case SET:
      return split_1 (x1, insn);

    case EH_RETURN:
      if (!
#line 7194 "../../gcc/config/sparc/sparc.md"
(epilogue_completed))
        return NULL;
      return gen_split_55 (insn, operands);

    default:
      return NULL;
    }
}
