/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!icc_register_operand (operands[1], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !arith_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != LSHIFTRT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      x8 = XEXP (x6, 1);
      switch (GET_CODE (x8))
        {
        case NE:
          return pattern33 (x6); /* [-1, 0] */

        case EQ:
          if (pattern33 (x6) != 0)
            return -1;
          return 1;

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x8;
          if (!arith_double_operand (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode)
            return -1;
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 2;

        case ZERO_EXTEND:
          if (GET_MODE (x8) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode)
            return -1;
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x10 = XEXP (x7, 1);
      if (GET_CODE (x10) != NE
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XEXP (x10, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode)
        return -1;
      x12 = XEXP (x7, 0);
      operands[2] = x12;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x10, 0);
      operands[1] = x13;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !arith_double_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !arith_add_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_TFmode:
      if (pattern4 (x1, 
E_TFmode) != 0)
        return -1;
      return 2;

    case E_DFmode:
      if (pattern4 (x1, 
E_DFmode) != 0)
        return -1;
      return 3;

    case E_SFmode:
      if (pattern4 (x1, 
E_SFmode) != 0)
        return -1;
      return 4;

    case E_V1SImode:
      if (pattern4 (x1, 
E_V1SImode) != 0)
        return -1;
      return 5;

    case E_V2SImode:
      if (pattern4 (x1, 
E_V2SImode) != 0)
        return -1;
      return 6;

    case E_V2HImode:
      if (pattern4 (x1, 
E_V2HImode) != 0)
        return -1;
      return 7;

    case E_V4HImode:
      if (pattern4 (x1, 
E_V4HImode) != 0)
        return -1;
      return 8;

    case E_V1DImode:
      if (pattern4 (x1, 
E_V1DImode) != 0)
        return -1;
      return 9;

    case E_V8QImode:
      if (pattern4 (x1, 
E_V8QImode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern103 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_CCFPEmode:
      switch (pattern68 (x3, 
E_CCFPEmode))
        {
        case 0:
          if (!
#line 695 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 3; /* *cmpsf_fpe */

        case 1:
          if (!
#line 707 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 4; /* *cmpdf_fpe */

        case 2:
          if (!
#line 720 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 5; /* *cmptf_fpe */

        default:
          return -1;
        }

    case E_CCFPmode:
      switch (pattern68 (x3, 
E_CCFPmode))
        {
        case 0:
          if (!
#line 732 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 6; /* *cmpsf_fp */

        case 1:
          if (!
#line 744 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 7; /* *cmpdf_fp */

        case 2:
          if (!
#line 757 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 8; /* *cmptf_fp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          switch (pattern23 (x3))
            {
            case 0:
              return 172; /* andsi3 */

            case 1:
              if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 326; /* andv1si3 */

            case 2:
              if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 329; /* andv2hi3 */

            case 3:
              if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 332; /* andv4qi3 */

            case 4:
              if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 335; /* andv1di3 */

            case 5:
              if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 338; /* andv2si3 */

            case 6:
              if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 341; /* andv4hi3 */

            case 7:
              if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 344; /* andv8qi3 */

            default:
              return -1;
            }

        case NOT:
          switch (pattern47 (x3))
            {
            case 0:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 389; /* *and_not2v1si_vis */

            case 1:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 391; /* *and_not2v2hi_vis */

            case 2:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 393; /* *and_not2v4qi_vis */

            case 3:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 395; /* *and_not2v1di_vis */

            case 4:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 397; /* *and_not2v2si_vis */

            case 5:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 399; /* *and_not2v4hi_vis */

            case 6:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 401; /* *and_not2v8qi_vis */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern49 (x3))
        {
        case 0:
          return 173; /* *and_not_si */

        case 1:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 375; /* *and_not1v1si_vis */

        case 2:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 377; /* *and_not1v2hi_vis */

        case 3:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 379; /* *and_not1v4qi_vis */

        case 4:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 381; /* *and_not1v1di_vis */

        case 5:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 383; /* *and_not1v2si_vis */

        case 6:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 385; /* *and_not1v4hi_vis */

        case 7:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 387; /* *and_not1v8qi_vis */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
      if (pattern13 (x3, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 10; /* *neg_snesisi_zero */

    case EQ:
      if (pattern13 (x3, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 12; /* *neg_seqsisi_zero */

    case GEU:
      if (pattern14 (x3) != 0
          || !
#line 1133 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
        return -1;
      return 22; /* *neg_sgeusi */

    case LTU:
      if (pattern14 (x3) != 0
          || !
#line 1209 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
        return -1;
      return 25; /* *neg_sltusi */

    case PLUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case LTU:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!icc_register_operand (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          if (!arith_operand (operands[1], E_SImode)
              || !
#line 1236 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
            return -1;
          return 27; /* *neg_plus_sltusi */

        case REG:
        case SUBREG:
          operands[1] = x5;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern24 (x3, 
E_SFmode) != 0
                  || !
#line 9363 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 514; /* *naddsf3 */

            case E_DFmode:
              if (pattern24 (x3, 
E_DFmode) != 0
                  || !
#line 9371 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 515; /* *nadddf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern6 (x3, pnum_clobbers, 
E_DImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 184; /* negdi2_sp32 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 187; /* negsi2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if (
#line 6259 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return 222; /* *negtf2_hq */
          if (!
#line 6266 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD))
            return -1;
          return 223; /* *negtf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 6307 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9))
            return 224; /* *negdf2_notv9 */
          if (!
#line 6342 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_V9))
            return -1;
          return 225; /* *negdf2_v9 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 6350 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 226; /* negsf2 */

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XEXP (x4, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern73 (x3, 
E_DFmode) != 0
                  || !
#line 6134 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 210; /* *nfmadf4 */

            case E_SFmode:
              if (pattern73 (x3, 
E_SFmode) != 0
                  || !
#line 6170 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 214; /* *nfmasf4 */

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern74 (x3, 
E_DFmode) != 0
                  || !
#line 6143 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 211; /* *nfmsdf4 */

            case E_SFmode:
              if (pattern74 (x3, 
E_SFmode) != 0
                  || !
#line 6179 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 215; /* *nfmssf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 56)
        return -1;
      x11 = XVECEXP (x4, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x4, 0, 1);
      operands[2] = x12;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern75 (x3, 
E_SFmode) != 0
              || !
#line 9447 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 523; /* fnhaddsf_vis */

        case E_DFmode:
          if (pattern75 (x3, 
E_DFmode) != 0
              || !
#line 9456 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 524; /* fnhadddf_vis */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case NE:
          if (pattern26 (x1) != 0)
            return -1;
          return 9; /* *snesisi_zero */

        case NEG:
          switch (pattern28 (x1))
            {
            case 0:
              return 10; /* *neg_snesisi_zero */

            case 1:
              return 12; /* *neg_seqsisi_zero */

            case 2:
              return 184; /* negdi2_sp32 */

            default:
              return -1;
            }

        case EQ:
          if (pattern26 (x1) != 0)
            return -1;
          return 11; /* *seqsisi_zero */

        case UNSPEC:
          switch (XVECLEN (x3, 0))
            {
            case 3:
              if (XINT (x3, 1) != 2)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 15)
                return -1;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              x7 = XVECEXP (x3, 0, 0);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 1);
              operands[2] = x8;
              x9 = XVECEXP (x3, 0, 2);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern93 (x1, 
E_SImode) != 0
                      || !(
#line 1598 "../../gcc/config/sparc/sparc.md"
(REGNO (operands[0]) == INTVAL (operands[3])) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 40; /* load_pcrel_symsi */

                case E_DImode:
                  if (pattern93 (x1, 
E_DImode) != 0
                      || !(
#line 1598 "../../gcc/config/sparc/sparc.md"
(REGNO (operands[0]) == INTVAL (operands[3])) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 41; /* load_pcrel_symdi */

                default:
                  return -1;
                }

            case 1:
              if (XINT (x3, 1) != 42
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              x10 = XEXP (x4, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              if (!memory_operand (operands[0], E_SImode))
                return -1;
              x7 = XVECEXP (x3, 0, 0);
              operands[1] = x7;
              if (!memory_operand (operands[1], E_SImode))
                return -1;
              x5 = XEXP (x4, 0);
              operands[2] = x5;
              if (!scratch_operand (operands[2], E_SImode))
                return -1;
              return 308; /* stack_protect_set32 */

            case 2:
              if (pnum_clobbers == NULL
                  || pattern53 (x1) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 309; /* stack_protect_test32 */

            default:
              return -1;
            }

        case COMPARE:
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 100)
            return -1;
          return recog_24 (x1, insn, pnum_clobbers);

        case TRUNCATE:
          if (pattern29 (x3) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x11 = XEXP (x3, 0);
          x12 = XEXP (x11, 0);
          x13 = XEXP (x12, 0);
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x11, 1);
          operands[3] = x14;
          if (!small_int_operand (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[4] = x5;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          switch (GET_CODE (x13))
            {
            case SIGN_EXTEND:
              x15 = XEXP (x13, 0);
              operands[1] = x15;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x16 = XEXP (x12, 1);
              switch (GET_CODE (x16))
                {
                case SIGN_EXTEND:
                  if (GET_MODE (x16) != E_DImode)
                    return -1;
                  x17 = XEXP (x16, 0);
                  operands[2] = x17;
                  if (!register_operand (operands[2], E_SImode)
                      || !
#line 4779 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                    return -1;
                  return 149; /* smulsi3_highpart_v8plus */

                case CONST_INT:
                  operands[2] = x16;
                  if (!small_int_operand (operands[2], E_DImode)
                      || !
#line 4810 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                    return -1;
                  return 151; /* const_smulsi3_highpart_v8plus */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x15 = XEXP (x13, 0);
              operands[1] = x15;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x16 = XEXP (x12, 1);
              switch (GET_CODE (x16))
                {
                case ZERO_EXTEND:
                  if (GET_MODE (x16) != E_DImode)
                    return -1;
                  x17 = XEXP (x16, 0);
                  operands[2] = x17;
                  if (!register_operand (operands[2], E_SImode)
                      || !
#line 4981 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                    return -1;
                  return 158; /* umulsi3_highpart_v8plus */

                case CONST_INT:
                  operands[2] = x16;
                  if (!uns_small_int_operand (operands[2], E_DImode)
                      || !
#line 4996 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                    return -1;
                  return 159; /* const_umulsi3_highpart_v8plus */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case DIV:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x18 = XEXP (x3, 1);
          operands[2] = x18;
          if (!input_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!scratch_operand (operands[3], E_SImode)
              || !
#line 5183 "../../gcc/config/sparc/sparc.md"
((TARGET_V8 || TARGET_DEPRECATED_V8_INSNS) && TARGET_ARCH32))
            return -1;
          return 165; /* divsi3_sp32 */

        case ASHIFT:
          if (pattern30 (x1) != 0
              || !
#line 6548 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 237; /* ashldi3_v8plus */

        case ASHIFTRT:
          if (pattern30 (x1) != 0
              || !
#line 6661 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 241; /* ashrdi3_v8plus */

        case LSHIFTRT:
          if (pattern30 (x1) != 0
              || !
#line 6756 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 243; /* lshrdi3_v8plus */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          switch (GET_CODE (x3))
            {
            case PLUS:
              res = recog_25 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case MINUS:
              switch (pattern34 (x1))
                {
                case 0:
                  return 15; /* *minus_snesisi_zero */

                case 1:
                  return 18; /* *minus_seqsisi_zero */

                case 2:
                  return 129; /* subdi3_sp32 */

                case 3:
                  return 133; /* *subdi3_extend_sp32 */

                case 4:
                  return 16; /* *minus_minus_snesisi_zero */

                default:
                  break;
                }
              break;

            case MULT:
              res = recog_26 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case CONST_INT:
            case REG:
            case SUBREG:
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              if (register_operand (operands[0], E_SImode))
                {
                  res = recog_28 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[0] = x3;
              if (arith_operand (operands[0], E_DImode)
                  && pattern67 (x1, 
CLOBBER, 
E_DImode, 
102) == 0)
                {
                  x4 = XVECEXP (x1, 0, 1);
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (scratch_operand (operands[1], E_SImode)
                      && 
#line 8807 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH32))
                    return 421; /* wrgsr_v8plus */
                }
              if (GET_CODE (x3) == REG
                  && REGNO (x3) == 102
                  && GET_MODE (x3) == E_DImode)
                {
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) == CLOBBER)
                    {
                      operands[0] = x6;
                      if (register_operand (operands[0], E_DImode))
                        {
                          x5 = XEXP (x4, 0);
                          operands[1] = x5;
                          if (scratch_operand (operands[1], E_SImode)
                              && 
#line 8839 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH32))
                            return 422; /* rdgsr_v8plus */
                        }
                    }
                }
              break;

            case MEM:
              res = recog_29 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[0] = x3;
          if (!address_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != PC)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != LABEL_REF)
            return -1;
          x19 = XEXP (x5, 0);
          operands[1] = x19;
          return 246; /* *tablejumpsi */

        case CALL:
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_SImode)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x12 = XEXP (x11, 0);
          switch (GET_CODE (x12))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case PLUS:
            case MINUS:
            case MULT:
            case AND:
            case SIGN_EXTEND:
            case ZERO_EXTEND:
            case HIGH:
              operands[1] = x12;
              x18 = XEXP (x3, 1);
              operands[2] = x18;
              x4 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x4))
                {
                case CLOBBER:
                  x5 = XEXP (x4, 0);
                  if (GET_CODE (x5) != REG
                      || REGNO (x5) != 15
                      || GET_MODE (x5) != E_SImode)
                    return -1;
                  if (address_operand (operands[1], E_SImode))
                    return 253; /* *call_value_addresssi */
                  if (!symbolic_operand (operands[1], E_SImode))
                    return -1;
                  return 254; /* *call_value_symbolicsi */

                case RETURN:
                  if (!symbolic_operand (operands[1], E_SImode))
                    return -1;
                  return 256; /* *sibcall_value_symbolicsi */

                default:
                  return -1;
                }

            case UNSPEC:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x5 = XEXP (x4, 0);
              if (pattern79 (x5, 
E_VOIDmode, 
E_SImode, 
15) != 0
                  || GET_MODE (x12) != E_SImode)
                return -1;
              switch (XVECLEN (x12, 0))
                {
                case 2:
                  if (XINT (x12, 1) != 17)
                    return -1;
                  x20 = XVECEXP (x12, 0, 0);
                  operands[1] = x20;
                  if (!symbolic_operand (operands[1], E_SImode))
                    return -1;
                  x21 = XVECEXP (x12, 0, 1);
                  operands[2] = x21;
                  if (!tgd_symbolic_operand (operands[2], E_VOIDmode))
                    return -1;
                  x18 = XEXP (x3, 1);
                  operands[3] = x18;
                  return 283; /* tgd_callsi */

                case 1:
                  if (XINT (x12, 1) != 18)
                    return -1;
                  x20 = XVECEXP (x12, 0, 0);
                  operands[1] = x20;
                  if (!symbolic_operand (operands[1], E_SImode))
                    return -1;
                  x18 = XEXP (x3, 1);
                  operands[2] = x18;
                  return 287; /* tldm_callsi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case POPCOUNT:
          if (pattern31 (x1) != 0
              || !
#line 7509 "../../gcc/config/sparc/sparc.md"
(TARGET_POPC && TARGET_ARCH32))
            return -1;
          return 271; /* popcountdi_v8plus */

        case CLZ:
          if (pattern31 (x1) != 0
              || !
#line 7576 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
            return -1;
          return 273; /* clzdi_v8plus */

        case UNSPEC_VOLATILE:
          if (XVECLEN (x3, 0) != 1)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          x5 = XEXP (x4, 0);
          if (!rtx_equal_p (x5, operands[1]))
            return -1;
          switch (XINT (x3, 1))
            {
            case 7:
              if (GET_MODE (x3) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || !memory_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[2] = x10;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 286 "../../gcc/config/sparc/sync.md"
((TARGET_V8 || TARGET_V9) && !sparc_fix_ut699))
                return -1;
              return 562; /* swapsi */

            case 6:
              if (GET_MODE (x3) != E_QImode)
                return -1;
              x10 = XEXP (x4, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
                  || !register_operand (operands[0], E_QImode)
                  || !memory_operand (operands[1], E_QImode)
                  || !
#line 325 "../../gcc/config/sparc/sync.md"
(!sparc_fix_ut699))
                return -1;
              return 563; /* ldstub */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x22 = XEXP (x6, 0);
      operands[0] = x22;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x4 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x4))
        {
        case CLOBBER:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 15
              || GET_MODE (x5) != E_SImode)
            return -1;
          if (address_operand (operands[0], E_SImode))
            return 247; /* *call_addresssi */
          if (!symbolic_operand (operands[0], E_SImode))
            return -1;
          return 248; /* *call_symbolicsi */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x4;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          if (address_operand (operands[0], E_SImode)
              && 
#line 6970 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) > 0))
            {
              *pnum_clobbers = 1;
              return 249; /* *call_address_struct_value_sp32 */
            }
          if (symbolic_operand (operands[0], E_SImode)
              && 
#line 6986 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) > 0))
            {
              *pnum_clobbers = 1;
              return 250; /* *call_symbolic_struct_value_sp32 */
            }
          if (address_operand (operands[0], E_SImode)
              && 
#line 7002 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) < 0))
            {
              *pnum_clobbers = 1;
              return 251; /* *call_address_untyped_struct_value_sp32 */
            }
          if (!symbolic_operand (operands[0], E_SImode)
              || !
#line 7015 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) < 0))
            return -1;
          *pnum_clobbers = 1;
          return 252; /* *call_symbolic_untyped_struct_value_sp32 */

        case RETURN:
          if (!symbolic_operand (operands[0], E_SImode))
            return -1;
          return 255; /* *sibcall_symbolicsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
