/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 102
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 102
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!register_or_zero_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_SImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  operands[3] = x2;
  return 0;
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  operands[3] = x2;
  if (!imm2_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode)
          || !register_operand (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode)
          || !register_operand (operands[2], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode)
          || !register_operand (operands[2], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern81 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_CCVmode
      || GET_MODE (x2) != E_CCVmode
      || !arith_add_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  return 0;
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !symbolic_operand (operands[1], i1)
      || !call_address_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_SImode)
      || !arith_operand (operands[2], E_SImode)
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LTU
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              if (memory_operand (operands[1], E_HImode))
                return 83; /* *zero_extendhisi2_insn */
              if (input_operand (operands[1], E_QImode)
                  && 
#line 3066 "../../gcc/config/sparc/sparc.md"
(GET_CODE (operands[1]) != CONST_INT))
                return 85; /* *zero_extendqisi2_insn */
            }
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && GET_MODE (x3) == E_HImode
              && input_operand (operands[1], E_QImode)
              && 
#line 3049 "../../gcc/config/sparc/sparc.md"
(GET_CODE (operands[1]) != CONST_INT))
            return 84; /* *zero_extendqihi2_insn */
          break;

        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x3) == E_DImode
              && register_operand (operands[1], E_SImode))
            return 86; /* *zero_extendsidi2_insn_sp32 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != MEM)
        return -1;
      switch (pattern43 (x3))
        {
        case 0:
          return 297; /* *tldo_ldub1si */

        case 1:
          return 298; /* *tldo_ldub2si */

        case 2:
          return 302; /* *tldo_lduh1si */

        default:
          return -1;
        }

    case PLUS:
      if (pattern42 (x3, 
PLUS) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!arith_operand (operands[2], E_SImode))
        return -1;
      return 118; /* *addx_extend_sp32 */

    case MINUS:
      if (pattern42 (x3, 
MINUS) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_or_zero_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!arith_operand (operands[2], E_SImode))
        return -1;
      return 132; /* *subx_extend_sp32 */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[0] = x4;
      if (register_operand (operands[0], E_SImode)
          && REGNO (x2) == 100
          && GET_MODE (x2) == E_CCmode
          && GET_MODE (x3) == E_CCmode)
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (arith_operand (operands[1], E_SImode))
            return 1; /* *cmpsi_insn */
        }
      operands[1] = x4;
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[0] = x4;
      if (register_operand (operands[0], E_QImode)
          && pattern37 (x1) == 0)
        return 88; /* *cmp_zero_qi */
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 3)
          || GET_MODE (x4) != E_QImode
          || pattern36 (x1, 
E_CCmode, 
E_SImode) != 0)
        return -1;
      return 91; /* *cmp_siqi_trunc */

    case NOT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT
          || REGNO (x2) != 100)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[0] = x6;
          if (!arith_operand (operands[0], E_SImode))
            return -1;
          switch (XWINT (x5, 0))
            {
            case -1L:
              if (GET_MODE (x2) != E_CCCmode
                  || GET_MODE (x3) != E_CCCmode)
                return -1;
              return 2; /* *cmpsi_sne */

            case 0L:
              if (GET_MODE (x2) != E_CCmode
                  || GET_MODE (x3) != E_CCmode)
                return -1;
              return 196; /* *cmp_cc_not */

            default:
              return -1;
            }

        case XOR:
          if (GET_MODE (x6) != E_SImode
              || XWINT (x5, 0) != 0L
              || GET_MODE (x2) != E_CCmode
              || GET_MODE (x3) != E_CCmode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          if (!register_or_zero_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[1] = x8;
          if (!arith_operand (operands[1], E_SImode))
            return -1;
          return 180; /* *cmp_cc_xor_not */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_SImode
          || pattern36 (x1, 
E_CCmode, 
E_QImode) != 0)
        return -1;
      return 87; /* *cmp_zero_extendqisi2 */

    case ZERO_EXTRACT:
      if (GET_MODE (x4) != E_SImode
          || pattern37 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      if (!small_int_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 2);
      operands[2] = x10;
      if (!small_int_operand (operands[2], E_SImode)
          || !
#line 3470 "../../gcc/config/sparc/sparc.md"
(INTVAL (operands[2]) > 19))
        return -1;
      return 96; /* *cmp_zero_extract */

    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || REGNO (x2) != 100)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (pattern80 (x1) != 0)
            return -1;
          return 121; /* *cmp_ccnz_plus */

        case REG:
        case SUBREG:
          if (!rtx_equal_p (x5, operands[0])
              || GET_MODE (x2) != E_CCCmode
              || GET_MODE (x3) != E_CCCmode
              || !arith_operand (operands[1], E_SImode))
            return -1;
          return 123; /* *cmp_ccc_plus */

        case UNSPEC:
          if (pattern81 (x1, 
62) != 0)
            return -1;
          return 126; /* *cmp_ccv_plus */

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || REGNO (x2) != 100)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!register_or_zero_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (pattern80 (x1) != 0)
            return -1;
          return 135; /* *cmp_ccnz_minus */

        case UNSPEC:
          if (pattern81 (x1, 
63) != 0)
            return -1;
          return 139; /* *cmp_ccv_minus */

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      operands[2] = x4;
      if (cc_arith_operator (operands[2], E_SImode)
          && pattern37 (x1) == 0)
        {
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          if (arith_operand (operands[0], E_SImode))
            {
              x9 = XEXP (x4, 1);
              operands[1] = x9;
              if (arith_operand (operands[1], E_SImode))
                return 178; /* *cmp_cc_arith_op */
            }
        }
      if (!cc_arith_not_operator (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != NOT
          || GET_MODE (x6) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x2) != 100
          || GET_MODE (x2) != E_CCmode
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!arith_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      if (!register_or_zero_operand (operands[1], E_SImode))
        return -1;
      return 182; /* *cmp_cc_arith_op_not */

    case NEG:
      if (GET_MODE (x4) != E_SImode
          || REGNO (x2) != 100)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) != 0L
              || GET_MODE (x2) != E_CCNZmode
              || GET_MODE (x3) != E_CCNZmode)
            return -1;
          return 188; /* *cmp_ccnz_neg */

        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 64
              || GET_MODE (x5) != E_SImode
              || GET_MODE (x2) != E_CCVmode
              || GET_MODE (x3) != E_CCVmode)
            return -1;
          x11 = XVECEXP (x5, 0, 0);
          if (!rtx_equal_p (x11, operands[0]))
            return -1;
          return 192; /* *cmp_ccv_neg */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern36 (x1, 
E_CCNZmode, 
E_SImode) != 0)
        return -1;
      return 238; /* *cmp_ccnz_ashift_1 */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x5, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_CODE (x3) != ZERO_EXTEND)
        return -1;
      x9 = XEXP (x4, 0);
      if (GET_MODE (x9) != E_CCmode
          || GET_MODE (x5) != E_CCmode
          || GET_MODE (x6) != E_SImode)
        return -1;
      x10 = XEXP (x3, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      return 89; /* *cmp_zero_extendqisi2_set */

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != PLUS
          || GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x7, 1);
      if (GET_CODE (x12) != LTU
          || GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 100
          || GET_MODE (x13) != E_CCCmode)
        return -1;
      x14 = XEXP (x12, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_CODE (x8) != PLUS
          || GET_MODE (x8) != E_DImode)
        return -1;
      x15 = XEXP (x8, 0);
      if (GET_CODE (x15) != PLUS
          || GET_MODE (x15) != E_DImode)
        return -1;
      x16 = XEXP (x15, 0);
      if (GET_CODE (x16) != ZERO_EXTEND
          || GET_MODE (x16) != E_DImode)
        return -1;
      x17 = XEXP (x15, 1);
      if (GET_CODE (x17) != ZERO_EXTEND
          || GET_MODE (x17) != E_DImode)
        return -1;
      x18 = XEXP (x8, 1);
      if (GET_CODE (x18) != LTU
          || GET_MODE (x18) != E_DImode)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 100
          || GET_MODE (x19) != E_CCCmode)
        return -1;
      x20 = XEXP (x18, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_CODE (x3) != PLUS
          || pattern109 (x3, 
E_CCCmode, 
PLUS) != 0
          || pattern111 (x4) != 0)
        return -1;
      x21 = XEXP (x11, 1);
      operands[2] = x21;
      if (!arith_operand (operands[2], E_SImode))
        return -1;
      x22 = XEXP (x16, 0);
      if (!rtx_equal_p (x22, operands[1]))
        return -1;
      x23 = XEXP (x17, 0);
      if (!rtx_equal_p (x23, operands[2]))
        return -1;
      x10 = XEXP (x3, 0);
      x24 = XEXP (x10, 0);
      if (!rtx_equal_p (x24, operands[1]))
        return -1;
      x25 = XEXP (x10, 1);
      if (!rtx_equal_p (x25, operands[2]))
        return -1;
      return 125; /* *cmp_ccc_plus_sltu_set */

    case MINUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != MINUS
          || pattern94 (x5, 
MINUS, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x5, 1);
      if (pattern106 (x8, 
E_CCmode, 
MINUS) != 0)
        return -1;
      x18 = XEXP (x8, 1);
      if (GET_CODE (x18) != ZERO_EXTEND
          || GET_MODE (x18) != E_DImode
          || GET_CODE (x3) != MINUS)
        return -1;
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != MINUS
          || GET_MODE (x10) != E_SImode)
        return -1;
      x25 = XEXP (x10, 1);
      if (GET_CODE (x25) != LTU
          || GET_MODE (x25) != E_SImode)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != REG
          || REGNO (x26) != 100
          || GET_MODE (x26) != E_CCmode)
        return -1;
      x27 = XEXP (x25, 1);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 0);
      if (GET_MODE (x9) != E_CCCmode
          || GET_MODE (x5) != E_CCCmode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x28 = XEXP (x11, 0);
      operands[1] = x28;
      if (!register_or_zero_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x7, 1);
      operands[2] = x12;
      if (!arith_operand (operands[2], E_SImode))
        return -1;
      x15 = XEXP (x8, 0);
      x16 = XEXP (x15, 0);
      x22 = XEXP (x16, 0);
      if (!rtx_equal_p (x22, operands[1]))
        return -1;
      x19 = XEXP (x18, 0);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      x24 = XEXP (x10, 0);
      if (!rtx_equal_p (x24, operands[1]))
        return -1;
      x29 = XEXP (x3, 1);
      if (!rtx_equal_p (x29, operands[2]))
        return -1;
      return 138; /* *cmp_ccc_minus_sltu_set */

    case NEG:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != PLUS
          || pattern94 (x5, 
NEG, 
E_CCCmode) != 0)
        return -1;
      x8 = XEXP (x5, 1);
      if (pattern106 (x8, 
E_CCCmode, 
PLUS) != 0
          || GET_CODE (x3) != NEG)
        return -1;
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != PLUS
          || GET_MODE (x10) != E_SImode)
        return -1;
      x25 = XEXP (x10, 1);
      if (GET_CODE (x25) != LTU
          || GET_MODE (x25) != E_SImode)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != REG
          || REGNO (x26) != 100
          || GET_MODE (x26) != E_CCCmode)
        return -1;
      x27 = XEXP (x25, 1);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern111 (x4) != 0)
        return -1;
      x15 = XEXP (x8, 0);
      x16 = XEXP (x15, 0);
      x22 = XEXP (x16, 0);
      if (!rtx_equal_p (x22, operands[1]))
        return -1;
      x24 = XEXP (x10, 0);
      if (!rtx_equal_p (x24, operands[1]))
        return -1;
      return 191; /* *cmp_ccc_neg_sltu_set */

    default:
      return -1;
    }
}
