/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern4 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern4 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern4 (x3, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SImode:
      return pattern24 (x1, 
E_V1SImode); /* [-1, 0] */

    case E_V2HImode:
      if (pattern24 (x1, 
E_V2HImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern24 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V1DImode:
      if (pattern24 (x1, 
E_V1DImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern24 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4HImode:
      if (pattern24 (x1, 
E_V4HImode) != 0)
        return -1;
      return 5;

    case E_V8QImode:
      if (pattern24 (x1, 
E_V8QImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != LTU
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCCmode)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  return 0;
}

int
pattern54 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LTU
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != E_CCCmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!text_segment_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern69 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern79 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != i3
      || GET_MODE (x1) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern92 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NEG)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (icc_comparison_operator (x3, E_VOIDmode))
    {
      operands[0] = x3;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) == REG
          && REGNO (x4) == 100)
        {
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) == PC)
            {
              x6 = XEXP (x2, 1);
              switch (GET_CODE (x6))
                {
                case LABEL_REF:
                  x7 = XEXP (x2, 2);
                  if (GET_CODE (x7) == PC)
                    {
                      x8 = XEXP (x6, 0);
                      operands[1] = x8;
                      return 33; /* *normal_branch */
                    }
                  break;

                case PC:
                  x7 = XEXP (x2, 2);
                  if (GET_CODE (x7) == LABEL_REF)
                    {
                      x9 = XEXP (x7, 0);
                      operands[1] = x9;
                      return 34; /* *inverted_branch */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  operands[1] = x3;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case LABEL_REF:
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC
          || !comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_CCFPmode:
          if (!fcc_register_operand (operands[0], E_CCFPmode))
            return -1;
          return 35; /* *normal_fp_branch */

        case E_CCFPEmode:
          if (!fcc_register_operand (operands[0], E_CCFPEmode))
            return -1;
          return 37; /* *normal_fpe_branch */

        default:
          return -1;
        }

    case PC:
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC
          || !comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_CCFPmode:
          if (!fcc_register_operand (operands[0], E_CCFPmode))
            return -1;
          return 36; /* *inverted_fp_branch */

        case E_CCFPEmode:
          if (!fcc_register_operand (operands[0], E_CCFPEmode))
            return -1;
          return 38; /* *inverted_fpe_branch */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[3] = x6;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!icc_or_fcc_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!icc_or_fcc_register_operand (operands[2], E_VOIDmode))
        return -1;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern89 (x2, 
E_QImode) != 0
              || !
#line 2836 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && !(QImode == DImode && TARGET_ARCH32)))
            return -1;
          return 76; /* *movqi_cc_v9 */

        case E_HImode:
          if (pattern89 (x2, 
E_HImode) != 0
              || !
#line 2836 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && !(HImode == DImode && TARGET_ARCH32)))
            return -1;
          return 77; /* *movhi_cc_v9 */

        case E_SImode:
          if (pattern89 (x2, 
E_SImode) != 0
              || !
#line 2836 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && !(SImode == DImode && TARGET_ARCH32)))
            return -1;
          return 78; /* *movsi_cc_v9 */

        case E_SFmode:
          if (pattern90 (x2, 
E_SFmode) != 0
              || !
#line 2858 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
            return -1;
          return 79; /* *movsf_cc_v9 */

        case E_DFmode:
          if (pattern90 (x2, 
E_DFmode) != 0
              || !
#line 2881 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
            return -1;
          return 80; /* movdf_cc_v9 */

        case E_TFmode:
          if (pattern90 (x2, 
E_TFmode) != 0)
            return -1;
          if (
#line 2906 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && TARGET_HARD_QUAD))
            return 81; /* *movtf_cc_hq_v9 */
          if (!
#line 2928 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && !TARGET_HARD_QUAD))
            return -1;
          return 82; /* *movtf_cc_v9 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !register_or_zero_operand (operands[1], E_SImode)
              || !arith_operand (operands[2], E_SImode))
            return -1;
          return 177; /* *xor_not_si */

        case E_V1SImode:
          if (pattern24 (x3, 
E_V1SImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 348; /* *not_xorv1si3 */

        case E_V2HImode:
          if (pattern24 (x3, 
E_V2HImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 351; /* *not_xorv2hi3 */

        case E_V4QImode:
          if (pattern24 (x3, 
E_V4QImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 354; /* *not_xorv4qi3 */

        case E_V1DImode:
          if (pattern24 (x3, 
E_V1DImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 357; /* *not_xorv1di3 */

        case E_V2SImode:
          if (pattern24 (x3, 
E_V2SImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 360; /* *not_xorv2si3 */

        case E_V4HImode:
          if (pattern24 (x3, 
E_V4HImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 363; /* *not_xorv4hi3 */

        case E_V8QImode:
          if (pattern24 (x3, 
E_V8QImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 366; /* *not_xorv8qi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !arith_operand (operands[1], E_SImode))
            return -1;
          return 195; /* one_cmplsi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 402; /* one_cmplv1si2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 403; /* one_cmplv2hi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 404; /* one_cmplv4qi2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 405; /* one_cmplv1di2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 406; /* one_cmplv2si2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 407; /* one_cmplv4hi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 408; /* one_cmplv8qi2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern25 (x3))
        {
        case 0:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 346; /* *not_iorv1si3 */

        case 1:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 349; /* *not_iorv2hi3 */

        case 2:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 352; /* *not_iorv4qi3 */

        case 3:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 355; /* *not_iorv1di3 */

        case 4:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 358; /* *not_iorv2si3 */

        case 5:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 361; /* *not_iorv4hi3 */

        case 6:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 364; /* *not_iorv8qi3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern25 (x3))
        {
        case 0:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 347; /* *not_andv1si3 */

        case 1:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 350; /* *not_andv2hi3 */

        case 2:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 353; /* *not_andv4qi3 */

        case 3:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 356; /* *not_andv1di3 */

        case 4:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 359; /* *not_andv2si3 */

        case 5:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 362; /* *not_andv4hi3 */

        case 6:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 365; /* *not_andv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (pattern95 (x5, 
E_DImode, 
SIGN_EXTEND) != 0)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x5, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x5, 1);
  x10 = XEXP (x9, 0);
  operands[2] = x10;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!small_int_operand (operands[3], E_SImode))
    return -1;
  x12 = XEXP (x6, 0);
  operands[4] = x12;
  if (!scratch_operand (operands[4], E_SImode)
      || !
#line 4795 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
    return -1;
  return 150; /* *sparc.md:4787 */
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case COMPARE:
      return recog_14 (x1, insn, pnum_clobbers);

    case NE:
      switch (pattern1 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 9; /* *snesisi_zero */

        case 1:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (NE == EQ || NE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 439; /* fpcmpne8si_vis */

        case 2:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (NE == EQ || NE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 443; /* fpcmpne16si_vis */

        case 3:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (NE == EQ || NE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 447; /* fpcmpne32si_vis */

        default:
          return -1;
        }

    case NEG:
      return recog_16 (x1, insn, pnum_clobbers);

    case EQ:
      switch (pattern1 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 11; /* *seqsisi_zero */

        case 1:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 438; /* fpcmpeq8si_vis */

        case 2:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 442; /* fpcmpeq16si_vis */

        case 3:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 446; /* fpcmpeq32si_vis */

        default:
          return -1;
        }

    case LTU:
      if (pattern2 (x1) != 0
          || !
#line 1106 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
        return -1;
      return 19; /* *sltusi_insn */

    case GEU:
      if (pattern2 (x1) != 0
          || !
#line 1262 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
        return -1;
      return 30; /* *sgeusi_insn */

    case IF_THEN_ELSE:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          x4 = XEXP (x3, 1);
          if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              res = recog_2 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[0] = x3;
          if (!comparison_operator (operands[0], E_VOIDmode))
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != LABEL_REF)
            return -1;
          x6 = XEXP (x2, 2);
          if (GET_CODE (x6) != PC)
            return -1;
          x7 = XEXP (x1, 0);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x3, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x4;
          if (!arith5_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (!
#line 1529 "../../gcc/config/sparc/sparc.md"
(TARGET_CBCOND))
            return -1;
          return 39; /* *cbcond_sp32 */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_12 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_17 (x1, insn, pnum_clobbers);

    case LO_SUM:
      return recog_18 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 3503 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 97; /* extendsfdf2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x2) != E_TFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode)
                  || !
#line 3517 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 98; /* *extendsftf2_hq */

            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 3530 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 99; /* *extenddftf2_hq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 3537 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 100; /* truncdfsf2 */

            case E_TFmode:
              if (!register_operand (operands[1], E_TFmode)
                  || !
#line 3552 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 101; /* *trunctfsf2_hq */

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || !
#line 3565 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 102; /* *trunctfdf2_hq */

        default:
          return -1;
        }

    case FLOAT:
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern38 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 3575 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 103; /* floatsisf2 */

            case 1:
              if (!
#line 3612 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 106; /* floatdisf2 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern38 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 3583 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 104; /* floatsidf2 */

            case 1:
              if (!
#line 3626 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 107; /* floatdidf2 */

            default:
              return -1;
            }

        case E_TFmode:
          switch (pattern38 (x2, 
E_TFmode))
            {
            case 0:
              if (!
#line 3597 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 105; /* *floatsitf2_hq */

            case 1:
              if (!
#line 3646 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 108; /* *floatditf2_hq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FIX:
      return recog_20 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_13 (x1, insn, pnum_clobbers);

    case DIV:
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern6 (x2, pnum_clobbers, 
E_SImode) != 0
              || !input_operand (operands[2], E_SImode)
              || !
#line 5183 "../../gcc/config/sparc/sparc.md"
((TARGET_V8 || TARGET_DEPRECATED_V8_INSNS) && TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 1;
          return 165; /* divsi3_sp32 */

        case E_TFmode:
          if (pattern4 (x2, 
E_TFmode) != 0
              || !
#line 6212 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 218; /* *divtf3_hq */

        case E_DFmode:
          if (pattern4 (x2, 
E_DFmode) != 0)
            return -1;
          if (
#line 6227 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
            return 219; /* *divdf3_nofix */
          if (!
#line 6236 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && sparc_fix_ut699))
            return -1;
          return 220; /* *divdf3_fix */

        case E_SFmode:
          if (pattern4 (x2, 
E_SFmode) != 0
              || !
#line 6246 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
            return -1;
          return 221; /* divsf3 */

        default:
          return -1;
        }

    case UDIV:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!input_operand (operands[2], E_SImode)
          || !
#line 5270 "../../gcc/config/sparc/sparc.md"
((TARGET_V8 || TARGET_DEPRECATED_V8_INSNS) && TARGET_ARCH32))
        return -1;
      return 167; /* udivsi3_sp32 */

    case XOR:
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern23 (x2))
        {
        case 0:
          return 176; /* xorsi3 */

        case 1:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 327; /* xorv1si3 */

        case 2:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 330; /* xorv2hi3 */

        case 3:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 333; /* xorv4qi3 */

        case 4:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 336; /* xorv1di3 */

        case 5:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 339; /* xorv2si3 */

        case 6:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 342; /* xorv4hi3 */

        case 7:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 345; /* xorv8qi3 */

        default:
          return -1;
        }

    case NOT:
      return recog_15 (x1, insn, pnum_clobbers);

    case FMA:
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern70 (x2, 
E_DFmode) != 0
                  || !
#line 6116 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 208; /* fmadf4 */

            case E_SFmode:
              if (pattern70 (x2, 
E_SFmode) != 0
                  || !
#line 6152 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 212; /* fmasf4 */

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x6, 0);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern71 (x2, 
E_DFmode) != 0
                  || !
#line 6125 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 209; /* fmsdf4 */

            case E_SFmode:
              if (pattern71 (x2, 
E_SFmode) != 0
                  || !
#line 6161 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 213; /* fmssf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      switch (pattern3 (x1))
        {
        case 0:
          if (
#line 6363 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return 227; /* *abstf2_hq */
          if (!
#line 6370 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD))
            return -1;
          return 228; /* *abstf2 */

        case 1:
          if (
#line 6411 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9))
            return 229; /* *absdf2_notv9 */
          if (!
#line 6446 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_V9))
            return -1;
          return 230; /* *absdf2_v9 */

        case 2:
          if (!
#line 6454 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 231; /* abssf2 */

        default:
          return -1;
        }

    case SQRT:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 6467 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 232; /* *sqrttf2_hq */

        case 1:
          if (
#line 6480 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
            return 233; /* *sqrtdf2_nofix */
          if (!
#line 6488 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && sparc_fix_ut699))
            return -1;
          return 234; /* *sqrtdf2_fix */

        case 2:
          if (!
#line 6497 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
            return -1;
          return 235; /* sqrtsf2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern5 (x1, pnum_clobbers))
        {
        case 0:
          return 236; /* ashlsi3 */

        case 1:
          if (!
#line 6548 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          *pnum_clobbers = 1;
          return 237; /* ashldi3_v8plus */

        case 2:
          if (!
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 474; /* vashlv4hi3 */

        case 3:
          if (!
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 478; /* vashlv2si3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern5 (x1, pnum_clobbers))
        {
        case 0:
          return 240; /* ashrsi3 */

        case 1:
          if (!
#line 6661 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          *pnum_clobbers = 1;
          return 241; /* ashrdi3_v8plus */

        case 2:
          if (!
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 477; /* vashrv4hi3 */

        case 3:
          if (!
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 481; /* vashrv2si3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern5 (x1, pnum_clobbers))
        {
        case 0:
          return 242; /* lshrsi3 */

        case 1:
          if (!
#line 6756 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          *pnum_clobbers = 1;
          return 243; /* lshrdi3_v8plus */

        case 2:
          if (!
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 476; /* vlshrv4hi3 */

        case 3:
          if (!
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 480; /* vlshrv2si3 */

        default:
          return -1;
        }

    case CALL:
      return recog_21 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (GET_MODE (x2) != E_SImode)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 2:
          if (XINT (x2, 1) != 2
              || !register_operand (operands[0], E_SImode))
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x12 = XVECEXP (x2, 0, 1);
          operands[2] = x12;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 263; /* probe_stack_rangesi */

        case 1:
          if (XINT (x2, 1) != 10)
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !memory_operand (operands[0], E_SImode)
              || !
#line 7480 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 270; /* stfsr */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case PLUS:
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MINUS:
          res = recog_4 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          res = recog_6 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case HIGH:
          res = recog_7 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ZERO_EXTEND:
          res = recog_8 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case SIGN_EXTEND:
          res = recog_9 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MULT:
          res = recog_10 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          res = recog_11 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case LABEL_REF:
          x7 = XEXP (x1, 0);
          if (GET_CODE (x7) == PC)
            {
              x3 = XEXP (x2, 0);
              operands[0] = x3;
              if (
#line 6828 "../../gcc/config/sparc/sparc.md"
(!TARGET_CBCOND))
                return 244; /* *jump_ubranch */
              if (
#line 6836 "../../gcc/config/sparc/sparc.md"
(TARGET_CBCOND))
                return 245; /* *jump_cbcond */
            }
          break;

        default:
          break;
        }
      operands[0] = x2;
      if (!address_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      return 266; /* *branchsi */

    case POPCOUNT:
      switch (pattern7 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 7509 "../../gcc/config/sparc/sparc.md"
(TARGET_POPC && TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 1;
          return 271; /* popcountdi_v8plus */

        case 1:
          if (!
#line 7544 "../../gcc/config/sparc/sparc.md"
(TARGET_POPC && TARGET_ARCH32))
            return -1;
          return 272; /* popcountsi_v8plus */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern7 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 7576 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 1;
          return 273; /* clzdi_v8plus */

        case 1:
          if (!
#line 7617 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
            return -1;
          return 274; /* clzsi_v8plus */

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_19 (x1, insn, pnum_clobbers);

    case LE:
      switch (pattern8 (x1))
        {
        case 0:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 440; /* fpcmple8si_vis */

        case 1:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 444; /* fpcmple16si_vis */

        case 2:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 448; /* fpcmple32si_vis */

        default:
          return -1;
        }

    case GT:
      switch (pattern8 (x1))
        {
        case 0:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 441; /* fpcmpgt8si_vis */

        case 1:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 445; /* fpcmpgt16si_vis */

        case 2:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 449; /* fpcmpgt32si_vis */

        default:
          return -1;
        }

    case LEU:
      switch (pattern8 (x1))
        {
        case 0:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V8QImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 450; /* fpcmpule8si_vis */

        case 1:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V4HImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 452; /* fpcmpule16si_vis */

        case 2:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V2SImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 454; /* fpcmpule32si_vis */

        default:
          return -1;
        }

    case GTU:
      switch (pattern8 (x1))
        {
        case 0:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V8QImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 451; /* fpcmpugt8si_vis */

        case 1:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V4HImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 453; /* fpcmpugt16si_vis */

        case 2:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V2SImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 455; /* fpcmpugt32si_vis */

        default:
          return -1;
        }

    case SS_ASHIFT:
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (pattern4 (x2, 
E_V4HImode) != 0
              || !
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 475; /* vssashlv4hi3 */

        case E_V2SImode:
          if (pattern4 (x2, 
E_V2SImode) != 0
              || !
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 479; /* vssashlv2si3 */

        default:
          return -1;
        }

    case SS_PLUS:
      switch (pattern9 (x1))
        {
        case 0:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 488; /* ssaddv4hi3 */

        case 1:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 490; /* ssaddv2si3 */

        case 2:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 492; /* ssaddv2hi3 */

        case 3:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 494; /* ssaddv1si3 */

        case 4:
          if (!
#line 9338 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 508; /* ssaddv8qi3 */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern9 (x1))
        {
        case 0:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 489; /* sssubv4hi3 */

        case 1:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 491; /* sssubv2si3 */

        case 2:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 493; /* sssubv2hi3 */

        case 3:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 495; /* sssubv1si3 */

        case 4:
          if (!
#line 9338 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 509; /* sssubv8qi3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 496; /* minv8qi3 */

        case 1:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 498; /* minv4hi3 */

        case 2:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 500; /* minv2si3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 497; /* maxv8qi3 */

        case 1:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 499; /* maxv4hi3 */

        case 2:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 501; /* maxv2si3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 502; /* minuv8qi3 */

        case 1:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 504; /* minuv4hi3 */

        case 2:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 506; /* minuv2si3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 503; /* maxuv8qi3 */

        case 1:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 505; /* maxuv4hi3 */

        case 2:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 507; /* maxuv2si3 */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 9354 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 510; /* usaddv4hi3 */

        case 1:
          if (!
#line 9354 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 512; /* usaddv8qi3 */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 9354 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 511; /* ussubv4hi3 */

        case 1:
          if (!
#line 9354 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 513; /* ussubv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
