/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !arith_operand (operands[1], E_DImode)
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern4 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern4 (x3, 
E_V2SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern22 (x1, 
E_SImode); /* [-1, 0] */

    case E_V1SImode:
      if (pattern4 (x1, 
E_V1SImode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern4 (x1, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V4QImode:
      if (pattern4 (x1, 
E_V4QImode) != 0)
        return -1;
      return 3;

    case E_V1DImode:
      if (pattern4 (x1, 
E_V1DImode) != 0)
        return -1;
      return 4;

    case E_V2SImode:
      if (pattern4 (x1, 
E_V2SImode) != 0)
        return -1;
      return 5;

    case E_V4HImode:
      if (pattern4 (x1, 
E_V4HImode) != 0)
        return -1;
      return 6;

    case E_V8QImode:
      if (pattern4 (x1, 
E_V8QImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern48 (x1, 
E_SImode); /* [-1, 0] */

    case E_V1SImode:
      if (pattern48 (x1, 
E_V1SImode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern48 (x1, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V4QImode:
      if (pattern48 (x1, 
E_V4QImode) != 0)
        return -1;
      return 3;

    case E_V1DImode:
      if (pattern48 (x1, 
E_V1DImode) != 0)
        return -1;
      return 4;

    case E_V2SImode:
      if (pattern48 (x1, 
E_V2SImode) != 0)
        return -1;
      return 5;

    case E_V4HImode:
      if (pattern48 (x1, 
E_V4HImode) != 0)
        return -1;
      return 6;

    case E_V8QImode:
      if (pattern48 (x1, 
E_V8QImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern78 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CCmode
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode)
      || pattern77 (x1) != 0)
    return -1;
  return 0;
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) != 0L)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_CCNZmode
      || GET_MODE (x2) != E_CCNZmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern99 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_or_zero_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  if (!arith_operand (operands[2], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_CCCmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CCCmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && GET_MODE (x3) == E_SImode)
        {
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (memory_operand (operands[1], E_HImode))
                return 93; /* *sign_extendhisi2_insn */
              break;

            case E_QImode:
              if (memory_operand (operands[1], E_QImode))
                return 95; /* *sign_extendqisi2_insn */
              break;

            default:
              break;
            }
        }
      break;

    case E_HImode:
      if (register_operand (operands[0], E_HImode)
          && GET_MODE (x3) == E_HImode
          && memory_operand (operands[1], E_QImode))
        return 94; /* *sign_extendqihi2_insn */
      break;

    default:
      break;
    }
  if (GET_CODE (x4) != MEM)
    return -1;
  switch (pattern43 (x3))
    {
    case 0:
      return 299; /* *tldo_ldsb1si */

    case 1:
      return 300; /* *tldo_ldsb2si */

    case 2:
      return 303; /* *tldo_ldsh1si */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (XINT (x2, 1))
        {
        case 2:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern82 (x2, 
E_SImode) != 0
                  || !(
#line 1598 "../../gcc/config/sparc/sparc.md"
(REGNO (operands[0]) == INTVAL (operands[3])) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              *pnum_clobbers = 1;
              return 40; /* load_pcrel_symsi */

            case E_DImode:
              if (pattern82 (x2, 
E_DImode) != 0
                  || !(
#line 1598 "../../gcc/config/sparc/sparc.md"
(REGNO (operands[0]) == INTVAL (operands[3])) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              *pnum_clobbers = 1;
              return 41; /* load_pcrel_symdi */

            default:
              return -1;
            }

        case 14:
          if (pattern55 (x2) != 0
              || !symbolic_operand (operands[3], E_VOIDmode)
              || !
#line 1741 "../../gcc/config/sparc/sparc.md"
(flag_pic && check_pic (1)))
            return -1;
          return 50; /* movsi_pic_gotdata_op */

        case 20:
          if (pattern55 (x2) != 0
              || !tie_symbolic_operand (operands[3], E_VOIDmode))
            return -1;
          return 293; /* tie_ld32 */

        case 24:
          if (GET_MODE (x2) != E_V8QImode)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 102
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_V8QImode)
              || !register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V8QImode)
              || !
#line 8685 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 411; /* fpack32_vis */

        case 31:
          switch (pattern56 (x2))
            {
            case 0:
              if (!
#line 8854 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 423; /* faligndatav1di_vis */

            case 1:
              if (!
#line 8854 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 424; /* faligndatav2si_vis */

            case 2:
              if (!
#line 8854 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 425; /* faligndatav4hi_vis */

            case 3:
              if (!
#line 8854 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 426; /* faligndatav8qi_vis */

            default:
              return -1;
            }

        case 32:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_V8QImode)
              || !register_operand (operands[2], E_V8QImode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!register_operand (operands[3], E_DImode)
              || !
#line 8912 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 431; /* pdist_vis */

        case 50:
          switch (pattern56 (x2))
            {
            case 0:
              if (!
#line 9105 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 460; /* bshufflev1di_vis */

            case 1:
              if (!
#line 9105 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 461; /* bshufflev2si_vis */

            case 2:
              if (!
#line 9105 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 462; /* bshufflev4hi_vis */

            case 3:
              if (!
#line 9105 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 463; /* bshufflev8qi_vis */

            default:
              return -1;
            }

        case 68:
          switch (pattern57 (x2))
            {
            case 0:
              if (!(
#line 9510 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 546; /* fpcmpde8sishl */

            case 1:
              if (!(
#line 9510 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 547; /* fpcmpde16sishl */

            case 2:
              if (!(
#line 9510 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 548; /* fpcmpde32sishl */

            default:
              return -1;
            }

        case 69:
          switch (pattern57 (x2))
            {
            case 0:
              if (!(
#line 9524 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 549; /* fpcmpur8sishl */

            case 1:
              if (!(
#line 9524 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 550; /* fpcmpur16sishl */

            case 2:
              if (!(
#line 9524 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 551; /* fpcmpur32sishl */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (XINT (x2, 1))
        {
        case 9:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 2061 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
            return -1;
          return 66; /* embmedany_brsum */

        case 3:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          return 261; /* *frame_blockagesi */

        case 26:
          if (GET_MODE (x2) != E_V4HImode
              || !register_operand (operands[0], E_V4HImode)
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 8694 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 412; /* fexpand_vis */

        case 16:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          if (register_operand (operands[0], E_DImode)
              && memory_operand (operands[1], E_DImode))
            return 557; /* atomic_loaddi_1 */
          if (!memory_operand (operands[0], E_DImode)
              || !register_or_v9_zero_operand (operands[1], E_DImode))
            return -1;
          return 558; /* atomic_storedi_1 */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 23:
          if (pattern15 (x1, 
E_V4HImode, 
E_V4QImode) != 0
              || !
#line 8664 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 409; /* fpack16_vis */

        case 25:
          if (pattern15 (x1, 
E_V2SImode, 
E_V2HImode) != 0
              || !
#line 8674 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 410; /* fpackfix_vis */

        case 59:
          if (pattern16 (x1, 
E_V4QImode) != 0
              || !
#line 8721 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 414; /* fmul8x16_vis */

        case 27:
          if (pattern17 (x1, 
E_V4HImode) != 0
              || !
#line 8731 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 415; /* fmul8x16au_vis */

        case 28:
          if (pattern17 (x1, 
E_V4HImode) != 0
              || !
#line 8741 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 416; /* fmul8x16al_vis */

        case 60:
          if (pattern16 (x1, 
E_V8QImode) != 0
              || !
#line 8751 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 417; /* fmul8sux16_vis */

        case 29:
          if (pattern16 (x1, 
E_V8QImode) != 0
              || !
#line 8761 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 418; /* fmul8ulx16_vis */

        case 61:
          if (pattern17 (x1, 
E_V2SImode) != 0
              || !
#line 8771 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 419; /* fmuld8sux16_vis */

        case 30:
          if (pattern17 (x1, 
E_V2SImode) != 0
              || !
#line 8781 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 420; /* fmuld8ulx16_vis */

        case 39:
          if (pattern18 (x1) != 0
              || !(
#line 9057 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 456; /* array8si_vis */

        case 40:
          if (pattern18 (x1) != 0
              || !(
#line 9066 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 457; /* array16si_vis */

        case 41:
          if (pattern18 (x1) != 0
              || !(
#line 9075 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 458; /* array32si_vis */

        case 44:
          if (pattern18 (x1) != 0
              || !(
#line 9132 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 464; /* edge8nsi_vis */

        case 45:
          if (pattern18 (x1) != 0
              || !(
#line 9141 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 465; /* edge8lnsi_vis */

        case 46:
          if (pattern18 (x1) != 0
              || !(
#line 9150 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 466; /* edge16nsi_vis */

        case 47:
          if (pattern18 (x1) != 0
              || !(
#line 9159 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 467; /* edge16lnsi_vis */

        case 48:
          if (pattern18 (x1) != 0
              || !(
#line 9168 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 468; /* edge32nsi_vis */

        case 49:
          if (pattern18 (x1) != 0
              || !(
#line 9177 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 469; /* edge32lnsi_vis */

        case 51:
          if (pattern19 (x1) != 0
              || !(
#line 9187 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 470; /* cmask8si_vis */

        case 52:
          if (pattern19 (x1) != 0
              || !(
#line 9197 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 471; /* cmask16si_vis */

        case 53:
          if (pattern19 (x1) != 0
              || !(
#line 9207 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 472; /* cmask32si_vis */

        case 54:
          if (GET_MODE (x2) != E_V4HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_V4HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!register_operand (operands[2], E_V4HImode)
              || !
#line 9217 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 473; /* fchksm16_vis */

        case 55:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!register_operand (operands[2], E_V8QImode)
              || !(
#line 9244 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 482; /* pdistnsi_vis */

        case 56:
          switch (pattern21 (x1))
            {
            case 0:
              if (!
#line 9409 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 519; /* fhaddsf_vis */

            case 1:
              if (!
#line 9418 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 520; /* fhadddf_vis */

            default:
              return -1;
            }

        case 57:
          switch (pattern21 (x1))
            {
            case 0:
              if (!
#line 9428 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 521; /* fhsubsf_vis */

            case 1:
              if (!
#line 9437 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 522; /* fhsubdf_vis */

            default:
              return -1;
            }

        case 65:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_DFmode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (!register_operand (operands[0], E_V8QImode)
                  || GET_MODE (x2) != E_V8QImode
                  || !imm5_operand_dictunpack8 (operands[2], E_SImode)
                  || !
#line 9474 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B))
                return -1;
              return 525; /* dictunpack8 */

            case E_V4HImode:
              if (!register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x2) != E_V4HImode
                  || !imm5_operand_dictunpack16 (operands[2], E_SImode)
                  || !
#line 9474 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B))
                return -1;
              return 526; /* dictunpack16 */

            case E_V2SImode:
              if (!register_operand (operands[0], E_V2SImode)
                  || GET_MODE (x2) != E_V2SImode
                  || !imm5_operand_dictunpack32 (operands[2], E_SImode)
                  || !
#line 9474 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B))
                return -1;
              return 527; /* dictunpack32 */

            default:
              return -1;
            }

        case 66:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[3] = x5;
          if (!imm2_operand (operands[3], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case EQ:
              switch (pattern83 (x4))
                {
                case 0:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 528; /* fpcmpeq8sishl */

                case 1:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 532; /* fpcmpeq16sishl */

                case 2:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 536; /* fpcmpeq32sishl */

                default:
                  return -1;
                }

            case NE:
              switch (pattern83 (x4))
                {
                case 0:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 529; /* fpcmpne8sishl */

                case 1:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 533; /* fpcmpne16sishl */

                case 2:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 537; /* fpcmpne32sishl */

                default:
                  return -1;
                }

            case LE:
              switch (pattern83 (x4))
                {
                case 0:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 530; /* fpcmple8sishl */

                case 1:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 534; /* fpcmple16sishl */

                case 2:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 538; /* fpcmple32sishl */

                default:
                  return -1;
                }

            case GT:
              switch (pattern83 (x4))
                {
                case 0:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 531; /* fpcmpgt8sishl */

                case 1:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 535; /* fpcmpgt16sishl */

                case 2:
                  if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 539; /* fpcmpgt32sishl */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 67:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[3] = x5;
          if (!imm2_operand (operands[3], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case LEU:
              switch (pattern83 (x4))
                {
                case 0:
                  if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 540; /* fpcmpule8sishl */

                case 1:
                  if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 542; /* fpcmpule16sishl */

                case 2:
                  if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 544; /* fpcmpule32sishl */

                default:
                  return -1;
                }

            case GTU:
              switch (pattern83 (x4))
                {
                case 0:
                  if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 541; /* fpcmpugt8sishl */

                case 1:
                  if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 543; /* fpcmpugt16sishl */

                case 2:
                  if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 545; /* fpcmpugt32sishl */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 15:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x5) != CONST_INT)
            return -1;
          operands[1] = x5;
          if (zero_or_v7_operand (operands[1], E_SImode))
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              x4 = XVECEXP (x2, 0, 0);
              if (rtx_equal_p (x4, operands[0]))
                return 552; /* *membar_empty */
            }
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          if (!rtx_equal_p (x4, operands[0]))
            return -1;
          switch (XWINT (x5, 0))
            {
            case 8L:
              if (
#line 63 "../../gcc/config/sparc/sync.md"
(TARGET_V8))
                return 553; /* *membar_storestore */
              break;

            case 2L:
              if (
#line 71 "../../gcc/config/sparc/sync.md"
(TARGET_V8))
                return 554; /* membar_storeload */
              break;

            default:
              break;
            }
          operands[1] = x5;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          if (
#line 89 "../../gcc/config/sparc/sync.md"
(TARGET_V8))
            return 555; /* *membar_v8 */
          if (!
#line 105 "../../gcc/config/sparc/sync.md"
(TARGET_V9))
            return -1;
          return 556; /* *membar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
