/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern4 (x3, 
E_V4HImode); /* [-1, 0] */

    case E_V8QImode:
      if (pattern4 (x3, 
E_V8QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_or_zero_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_or_zero_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!arith_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern39 (x1, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != 43
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern64 (x1, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) != 0L)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_CCNZmode
      || GET_MODE (x2) != E_CCNZmode
      || !arith_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern88 (rtx x1, machine_mode i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != i3
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern94 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != LTU
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x5, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x1, 1);
  if (GET_CODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != LTU
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !immediate_operand (operands[1], E_SImode)
              || !
#line 1704 "../../gcc/config/sparc/sparc.md"
(!flag_pic))
            return -1;
          return 47; /* *movsi_high */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          if (medium_pic_operand (operands[1], E_DImode)
              && 
#line 1976 "../../gcc/config/sparc/sparc.md"
((TARGET_CM_MEDLOW || TARGET_CM_EMBMEDANY) && flag_pic && check_pic (1)))
            return 54; /* *sethi_di_medlow_embmedany_pic */
          if (!symbolic_operand (operands[1], E_DImode)
              || !
#line 1982 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDLOW && !flag_pic))
            return -1;
          return 55; /* *sethi_di_medlow */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !fp_const_high_losum_operand (operands[1], E_SFmode))
            return -1;
          return 73; /* *movsf_high */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          switch (XINT (x4, 1))
            {
            case 0:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!
#line 1726 "../../gcc/config/sparc/sparc.md"
(flag_pic && check_pic (1)))
                return -1;
              return 49; /* movsi_high_pic */

            case 5:
              if (pattern61 (x3, 
E_DImode) != 0
                  || !
#line 1996 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDMID && !flag_pic))
                return -1;
              return 57; /* seth44 */

            case 7:
              if (pattern61 (x3, 
E_DImode) != 0
                  || !
#line 2018 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDANY && !flag_pic))
                return -1;
              return 60; /* sethh */

            case 8:
              if (pattern61 (x3, 
E_DImode) != 0
                  || !
#line 2025 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDANY && !flag_pic))
                return -1;
              return 61; /* setlm */

            case 9:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!data_segment_operand (operands[1], E_DImode)
                  || !
#line 2047 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
                return -1;
              return 64; /* embmedany_sethi */

            case 10:
              if (pattern62 (x3) != 0
                  || !
#line 2068 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
                return -1;
              return 67; /* embmedany_textuhi */

            case 11:
              if (pattern62 (x3) != 0
                  || !
#line 2075 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
                return -1;
              return 68; /* embmedany_texthi */

            case 17:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tgd_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              return 280; /* tgd_hi22si */

            case 18:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              x5 = XVECEXP (x4, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              return 284; /* tldm_hi22si */

            case 19:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tld_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              return 288; /* tldo_hix22si */

            case 20:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tie_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              return 291; /* tie_hi22si */

            case 21:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tle_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              return 294; /* tle_hix22si */

            default:
              return -1;
            }

        case 2:
          if (XINT (x4, 1) != 4
              || pattern61 (x3, 
E_SImode) != 0)
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[2] = x6;
          if (!
#line 1782 "../../gcc/config/sparc/sparc.md"
(flag_pic))
            return -1;
          return 51; /* *movsi_high_pic_label_ref */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !small_int_operand (operands[2], E_HImode))
                return -1;
              return 44; /* *movhi_lo_sum */

            case E_SImode:
              if (pattern22 (x3, 
E_SImode) != 0)
                return -1;
              return 174; /* iorsi3 */

            case E_V1SImode:
              if (pattern4 (x3, 
E_V1SImode) != 0
                  || !
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 325; /* iorv1si3 */

            case E_V2HImode:
              if (pattern4 (x3, 
E_V2HImode) != 0
                  || !
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 328; /* iorv2hi3 */

            case E_V4QImode:
              if (pattern4 (x3, 
E_V4QImode) != 0
                  || !
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 331; /* iorv4qi3 */

            case E_V1DImode:
              if (pattern4 (x3, 
E_V1DImode) != 0
                  || !
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 334; /* iorv1di3 */

            case E_V2SImode:
              if (pattern4 (x3, 
E_V2SImode) != 0
                  || !
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 337; /* iorv2si3 */

            case E_V4HImode:
              if (pattern4 (x3, 
E_V4HImode) != 0
                  || !
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 340; /* iorv4hi3 */

            case E_V8QImode:
              if (pattern4 (x3, 
E_V8QImode) != 0
                  || !
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 343; /* iorv8qi3 */

            default:
              return -1;
            }

        case NOT:
          switch (pattern47 (x3))
            {
            case 0:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 388; /* *ior_not2v1si_vis */

            case 1:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 390; /* *ior_not2v2hi_vis */

            case 2:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 392; /* *ior_not2v4qi_vis */

            case 3:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 394; /* *ior_not2v1di_vis */

            case 4:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 396; /* *ior_not2v2si_vis */

            case 5:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 398; /* *ior_not2v4hi_vis */

            case 6:
              if (!
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 400; /* *ior_not2v8qi_vis */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern49 (x3))
            {
            case 0:
              return 175; /* *or_not_si */

            case 1:
              if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 374; /* *ior_not1v1si_vis */

            case 2:
              if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 376; /* *ior_not1v2hi_vis */

            case 3:
              if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 378; /* *ior_not1v4qi_vis */

            case 4:
              if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 380; /* *ior_not1v1di_vis */

            case 5:
              if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 382; /* *ior_not1v2si_vis */

            case 6:
              if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 384; /* *ior_not1v4hi_vis */

            case 7:
              if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 386; /* *ior_not1v8qi_vis */

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V1SImode:
              if (pattern69 (x3, 
E_V1SImode) != 0
                  || !
#line 8624 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 367; /* *nandv1si_vis */

            case E_V2HImode:
              if (pattern69 (x3, 
E_V2HImode) != 0
                  || !
#line 8624 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 368; /* *nandv2hi_vis */

            case E_V4QImode:
              if (pattern69 (x3, 
E_V4QImode) != 0
                  || !
#line 8624 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 369; /* *nandv4qi_vis */

            case E_V1DImode:
              if (pattern69 (x3, 
E_V1DImode) != 0
                  || !
#line 8624 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 370; /* *nandv1di_vis */

            case E_V2SImode:
              if (pattern69 (x3, 
E_V2SImode) != 0
                  || !
#line 8624 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 371; /* *nandv2si_vis */

            case E_V4HImode:
              if (pattern69 (x3, 
E_V4HImode) != 0
                  || !
#line 8624 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 372; /* *nandv4hi_vis */

            case E_V8QImode:
              if (pattern69 (x3, 
E_V8QImode) != 0
                  || !
#line 8624 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 373; /* *nandv8qi_vis */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      if (XWINT (x4, 0) != 0L
          || !memory_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!memory_operand (operands[1], E_SImode))
        return NULL;
      if (
#line 7638 "../../gcc/config/sparc/sparc.md"
(TARGET_V9
   && mems_ok_for_ldd_peep (operands[0], operands[1], NULL_RTX)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_1 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!
#line 7650 "../../gcc/config/sparc/sparc.md"
(TARGET_V9
   && mems_ok_for_ldd_peep (operands[1], operands[0], NULL_RTX)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_2 (insn, operands);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode))
            {
              if (memory_operand (operands[1], E_SImode))
                {
                  x6 = XEXP (x3, 0);
                  operands[2] = x6;
                  if (register_operand (operands[2], E_SImode))
                    {
                      x5 = XEXP (x3, 1);
                      operands[3] = x5;
                      if (memory_operand (operands[3], E_SImode)
                          && 
#line 7662 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[0], operands[2]) 
   && mems_ok_for_ldd_peep (operands[1], operands[3], operands[0])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_3 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
              if (register_operand (operands[1], E_SImode))
                {
                  x5 = XEXP (x3, 1);
                  if (GET_CODE (x5) == COMPARE
                      && GET_MODE (x5) == E_CCmode)
                    {
                      x7 = XEXP (x5, 1);
                      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                        {
                          x6 = XEXP (x3, 0);
                          if (GET_CODE (x6) == REG
                              && REGNO (x6) == 100
                              && GET_MODE (x6) == E_CCmode)
                            {
                              x8 = XEXP (x5, 0);
                              operands[2] = x8;
                              if (register_operand (operands[2], E_SImode)
                                  && 
#line 7771 "../../gcc/config/sparc/sparc.md"
((rtx_equal_p (operands[2], operands[0])
    || rtx_equal_p (operands[2], operands[1]))
    && !SPARC_FP_REG_P (REGNO (operands[0]))
    && !SPARC_FP_REG_P (REGNO (operands[1]))))
                                {
                                  *pmatch_len_ = 1;
                                  res = gen_peephole2_11 (insn, operands);
                                  if (res != NULL_RTX)
                                    return res;
                                }
                            }
                        }
                    }
                }
            }
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (memory_operand (operands[2], E_SImode)
              && memory_operand (operands[0], E_SImode)
              && register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (register_operand (operands[3], E_SImode)
                  && 
#line 7675 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[1], operands[3]) 
   && mems_ok_for_ldd_peep (operands[0], operands[2], NULL_RTX)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_4 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (register_operand (operands[2], E_SImode)
              && register_operand (operands[0], E_SImode)
              && memory_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (memory_operand (operands[3], E_SImode)
                  && 
#line 7714 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[2], operands[0]) 
  && mems_ok_for_ldd_peep (operands[3], operands[1], operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_7 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_SImode)
              || !memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode)
              || !
#line 7727 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[3], operands[1]) 
  && mems_ok_for_ldd_peep (operands[2], operands[0], NULL_RTX)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        case E_SFmode:
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (register_operand (operands[2], E_SFmode)
              && register_operand (operands[0], E_SFmode)
              && memory_operand (operands[1], E_SFmode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (memory_operand (operands[3], E_SFmode)
                  && 
#line 7688 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[0], operands[2]) 
   && mems_ok_for_ldd_peep (operands[1], operands[3], operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_5 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (memory_operand (operands[2], E_SFmode)
              && memory_operand (operands[0], E_SFmode)
              && register_operand (operands[1], E_SFmode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (register_operand (operands[3], E_SFmode)
                  && 
#line 7701 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[1], operands[3]) 
  && mems_ok_for_ldd_peep (operands[0], operands[2], NULL_RTX)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_6 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (register_operand (operands[2], E_SFmode)
              && register_operand (operands[0], E_SFmode)
              && memory_operand (operands[1], E_SFmode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (memory_operand (operands[3], E_SFmode)
                  && 
#line 7740 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[2], operands[0]) 
  && mems_ok_for_ldd_peep (operands[3], operands[1], operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_9 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_SFmode)
              || !memory_operand (operands[0], E_SFmode)
              || !register_operand (operands[1], E_SFmode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SFmode)
              || !
#line 7753 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[3], operands[1]) 
  && mems_ok_for_ldd_peep (operands[2], operands[0], NULL_RTX)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_10 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 15
          || GET_MODE (x4) != E_BLKmode)
        return NULL;
      x9 = XVECEXP (x4, 0, 1);
      operands[1] = x9;
      if (!const_int_operand (operands[1], E_SImode))
        return NULL;
      x10 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 15
          || GET_MODE (x5) != E_BLKmode)
        return NULL;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      x11 = XVECEXP (x5, 0, 1);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_SImode))
        return NULL;
      x12 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x12, operands[2]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_12 (insn, operands);

    default:
      return NULL;
    }
}
