/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern6 (x3, pnum_clobbers, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!icc_register_operand (operands[1], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern24 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern36 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != 100
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], i2))
    return -1;
  return 0;
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern63 (x5, 
i1); /* [-1, 0] */
}

int
pattern74 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern63 (x1, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern90 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern97 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_add_operand (operands[2], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NE:
          if (pattern51 (x3, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 15; /* *minus_snesisi_zero */

        case EQ:
          if (pattern51 (x3, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 18; /* *minus_seqsisi_zero */

        case GEU:
          if (pattern52 (x3) != 0
              || !
#line 1151 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
            return -1;
          return 23; /* *minus_sgeusi */

        case LTU:
          if (pattern52 (x3) != 0
              || !
#line 1245 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
            return -1;
          return 28; /* *minus_sltusi */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          operands[1] = x4;
          switch (pattern72 (x3, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 129; /* subdi3_sp32 */

            case 1:
              return 134; /* subsi3 */

            case 2:
              if (!
#line 6058 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 202; /* *subtf3_hq */

            case 3:
              if (!
#line 6066 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 203; /* subdf3 */

            case 4:
              if (!
#line 6075 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 204; /* subsf3 */

            case 5:
              if (!
#line 8588 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 318; /* subv1si3 */

            case 6:
              if (!
#line 8588 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 320; /* subv2si3 */

            case 7:
              if (!
#line 8588 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 322; /* subv2hi3 */

            case 8:
              if (!
#line 8588 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 324; /* subv4hi3 */

            case 9:
              if (!
#line 9271 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B))
                return -1;
              return 485; /* fpsub64_vis */

            case 10:
              if (!
#line 9280 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
                return -1;
              return 487; /* subv8qi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 133; /* *subdi3_extend_sp32 */

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case NE:
          if (pnum_clobbers == NULL
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x7, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x4, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 16; /* *minus_minus_snesisi_zero */

        case LTU:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x7, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!register_or_zero_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x7, 0);
          operands[3] = x10;
          if (!icc_register_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!arith_operand (operands[2], E_SImode)
              || !
#line 1255 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode))
            return -1;
          return 29; /* *minus_minus_sltusi */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!arith_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != LTU
              || GET_MODE (x5) != E_SImode)
            return -1;
          x11 = XEXP (x5, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!register_or_zero_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (!icc_register_operand (operands[3], E_VOIDmode)
              || !
#line 1281 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode))
            return -1;
          return 32; /* *subxsi */

        default:
          return -1;
        }

    case NEG:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x4, 0);
      if (GET_CODE (x9) != LTU
          || GET_MODE (x9) != E_SImode)
        return -1;
      x12 = XEXP (x9, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x13 = XEXP (x9, 0);
      operands[2] = x13;
      if (!icc_register_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!arith_operand (operands[1], E_SImode)
          || !
#line 1227 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
        return -1;
      return 26; /* *minus_neg_sltusi */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_CONCAT
      || GET_MODE (x3) != E_V8QImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 8)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x9 = XVECEXP (x4, 0, 4);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x10 = XVECEXP (x4, 0, 5);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x11 = XVECEXP (x4, 0, 6);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x12 = XVECEXP (x4, 0, 7);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x13 = XEXP (x1, 0);
  operands[0] = x13;
  if (!register_operand (operands[0], E_V8QImode))
    return -1;
  x14 = XEXP (x3, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_V4QImode))
    return -1;
  x15 = XEXP (x3, 1);
  operands[2] = x15;
  if (!register_operand (operands[2], E_V4QImode)
      || !
#line 8709 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
    return -1;
  return 413; /* fpmerge_vis */
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) == AND
      && GET_MODE (x4) == E_SImode)
    {
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) == CONST_INT
          && XWINT (x5, 0) == 255L)
        {
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) == ZERO_EXTEND
              && GET_MODE (x7) == E_SImode)
            {
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) == SUBREG
                  && known_eq (SUBREG_BYTE (x8), 0)
                  && GET_MODE (x8) == E_QImode)
                {
                  x9 = XEXP (x4, 0);
                  operands[1] = x9;
                  if (register_operand (operands[1], E_SImode))
                    {
                      x10 = XEXP (x8, 0);
                      if (rtx_equal_p (x10, operands[1]))
                        return 90; /* *cmp_zero_extendqisi2_andcc_set */
                    }
                }
            }
        }
    }
  operands[3] = x4;
  if (!cc_arith_not_operator (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x4, 0);
  if (GET_CODE (x9) != NOT
      || GET_MODE (x9) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (!cc_arith_not_operator (x7, E_SImode))
    return -1;
  operands[4] = x7;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != NOT
      || GET_MODE (x8) != E_SImode)
    return -1;
  x11 = XEXP (x9, 0);
  operands[1] = x11;
  if (!arith_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!register_or_zero_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x12 = XEXP (x7, 1);
  if (!rtx_equal_p (x12, operands[2])
      || !
#line 5634 "../../gcc/config/sparc/sparc.md"
(GET_CODE (operands[3]) == GET_CODE (operands[4])))
    return -1;
  return 183; /* *cmp_cc_arith_op_not_set */
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pattern45 (x1, 
E_DImode) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 4670 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 145; /* mulsidi3_v8plus */

        case CONST_INT:
          operands[2] = x8;
          if (!small_int_operand (operands[2], E_DImode)
              || !
#line 4682 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 146; /* const_mulsidi3_v8plus */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 4872 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 154; /* umulsidi3_v8plus */

        case CONST_INT:
          operands[2] = x8;
          if (!uns_small_int_operand (operands[2], E_DImode)
              || !
#line 4936 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 157; /* const_umulsidi3_v8plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_31 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return recog_30 (x1, insn, pnum_clobbers);

        case 3:
          x2 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x3))
            {
            case SET:
              x4 = XEXP (x2, 0);
              if (!scratch_operand (x4, E_SImode))
                return -1;
              x5 = XEXP (x3, 1);
              switch (GET_CODE (x5))
                {
                case MULT:
                  if (GET_MODE (x5) != E_DImode)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != CLOBBER)
                    return -1;
                  x7 = XEXP (x3, 0);
                  operands[0] = x7;
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  x8 = XEXP (x5, 0);
                  operands[1] = x8;
                  if (!arith_operand (operands[1], E_DImode))
                    return -1;
                  x9 = XEXP (x5, 1);
                  operands[2] = x9;
                  if (!arith_operand (operands[2], E_DImode))
                    return -1;
                  x10 = XEXP (x6, 0);
                  operands[3] = x10;
                  if (!scratch_operand (operands[3], E_SImode))
                    return -1;
                  operands[4] = x4;
                  if (!
#line 4619 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                    return -1;
                  return 143; /* muldi3_v8plus */

                case TRUNCATE:
                  if (pattern45 (x1, 
E_TImode) != 0)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  x10 = XEXP (x6, 0);
                  operands[3] = x10;
                  if (!scratch_operand (operands[3], E_SImode))
                    return -1;
                  operands[4] = x4;
                  x8 = XEXP (x5, 0);
                  switch (GET_CODE (x8))
                    {
                    case LSHIFTRT:
                      x11 = XEXP (x8, 1);
                      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
                        return -1;
                      x12 = XEXP (x8, 0);
                      if (GET_MODE (x12) != E_TImode)
                        return -1;
                      switch (GET_CODE (x12))
                        {
                        case MULT:
                          if (pattern95 (x12, 
E_TImode, 
ZERO_EXTEND) != 0)
                            return -1;
                          x13 = XEXP (x12, 0);
                          x14 = XEXP (x13, 0);
                          operands[1] = x14;
                          if (!arith_operand (operands[1], E_DImode))
                            return -1;
                          x15 = XEXP (x12, 1);
                          x16 = XEXP (x15, 0);
                          operands[2] = x16;
                          if (!arith_operand (operands[2], E_DImode)
                              || !
#line 5064 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
                            return -1;
                          return 162; /* umulxhi_v8plus */

                        case UNSPEC:
                          if (XVECLEN (x12, 0) != 2
                              || XINT (x12, 1) != 58)
                            return -1;
                          x17 = XVECEXP (x12, 0, 0);
                          if (GET_CODE (x17) != ZERO_EXTEND
                              || GET_MODE (x17) != E_TImode)
                            return -1;
                          x18 = XVECEXP (x12, 0, 1);
                          if (GET_CODE (x18) != ZERO_EXTEND
                              || GET_MODE (x18) != E_TImode)
                            return -1;
                          x19 = XEXP (x17, 0);
                          operands[1] = x19;
                          if (!arith_operand (operands[1], E_DImode))
                            return -1;
                          x20 = XEXP (x18, 0);
                          operands[2] = x20;
                          if (!arith_operand (operands[2], E_DImode)
                              || !
#line 5150 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
                            return -1;
                          return 164; /* xmulxhi_v8plus */

                        default:
                          return -1;
                        }

                    case UNSPEC:
                      if (XVECLEN (x8, 0) != 2
                          || XINT (x8, 1) != 58)
                        return -1;
                      x21 = XVECEXP (x8, 0, 0);
                      if (GET_CODE (x21) != ZERO_EXTEND
                          || GET_MODE (x21) != E_TImode)
                        return -1;
                      x22 = XVECEXP (x8, 0, 1);
                      if (GET_CODE (x22) != ZERO_EXTEND
                          || GET_MODE (x22) != E_TImode)
                        return -1;
                      x23 = XEXP (x21, 0);
                      operands[1] = x23;
                      if (!arith_operand (operands[1], E_DImode))
                        return -1;
                      x24 = XEXP (x22, 0);
                      operands[2] = x24;
                      if (!arith_operand (operands[2], E_DImode)
                          || !
#line 5104 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
                        return -1;
                      return 163; /* xmulx_v8plus */

                    default:
                      return -1;
                    }

                case COMPARE:
                  if (GET_MODE (x5) != E_CCmode)
                    return -1;
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != DIV
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x9 = XEXP (x5, 1);
                  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                      || pattern67 (x1, 
SET, 
E_CCmode, 
100) != 0)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  x25 = XEXP (x6, 1);
                  if (GET_CODE (x25) != DIV
                      || GET_MODE (x25) != E_SImode)
                    return -1;
                  x12 = XEXP (x8, 0);
                  operands[1] = x12;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x11 = XEXP (x8, 1);
                  operands[2] = x11;
                  if (!arith_operand (operands[2], E_SImode))
                    return -1;
                  x10 = XEXP (x6, 0);
                  operands[0] = x10;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  operands[3] = x4;
                  x26 = XEXP (x25, 0);
                  if (!rtx_equal_p (x26, operands[1]))
                    return -1;
                  x27 = XEXP (x25, 1);
                  if (!rtx_equal_p (x27, operands[2])
                      || !
#line 5240 "../../gcc/config/sparc/sparc.md"
(TARGET_V8 || TARGET_DEPRECATED_V8_INSNS))
                    return -1;
                  return 166; /* *cmp_sdiv_cc_set */

                case UNSPEC:
                  if (XVECLEN (x5, 0) != 2
                      || pattern53 (x1) != 0)
                    return -1;
                  operands[2] = x4;
                  return 309; /* stack_protect_test32 */

                default:
                  return -1;
                }

            case CALL:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != MEM
                  || GET_MODE (x7) != E_SImode)
                return -1;
              x4 = XEXP (x2, 0);
              if (GET_CODE (x4) != REG
                  || REGNO (x4) != 15
                  || GET_MODE (x4) != E_SImode)
                return -1;
              x28 = XEXP (x7, 0);
              operands[0] = x28;
              x5 = XEXP (x3, 1);
              operands[1] = x5;
              x6 = XVECEXP (x1, 0, 1);
              operands[2] = x6;
              if (!immediate_operand (operands[2], E_VOIDmode))
                return -1;
              if (address_operand (operands[0], E_SImode)
                  && 
#line 6970 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) > 0))
                return 249; /* *call_address_struct_value_sp32 */
              if (symbolic_operand (operands[0], E_SImode)
                  && 
#line 6986 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) > 0))
                return 250; /* *call_symbolic_struct_value_sp32 */
              if (address_operand (operands[0], E_SImode)
                  && 
#line 7002 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) < 0))
                return 251; /* *call_address_untyped_struct_value_sp32 */
              if (!symbolic_operand (operands[0], E_SImode)
                  || !
#line 7015 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) < 0))
                return -1;
              return 252; /* *call_symbolic_untyped_struct_value_sp32 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x29 = XEXP (x1, 0);
      if (GET_CODE (x29) != MEM
          || GET_MODE (x29) != E_SImode)
        return -1;
      x30 = XEXP (x29, 0);
      operands[0] = x30;
      x31 = XEXP (x1, 1);
      operands[1] = x31;
      if (address_operand (operands[0], E_SImode))
        {
          *pnum_clobbers = 1;
          return 247; /* *call_addresssi */
        }
      if (!symbolic_operand (operands[0], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 248; /* *call_symbolicsi */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 4:
          x3 = XVECEXP (x1, 0, 0);
          operands[0] = x3;
          if (!arith_operand (operands[0], E_VOIDmode)
              || !
#line 7155 "../../gcc/config/sparc/sparc.md"
(!TARGET_FLAT))
            return -1;
          return 257; /* window_save */

        case 0:
          x3 = XVECEXP (x1, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 260; /* blockage */

        case 1:
          x3 = XVECEXP (x1, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 7270 "../../gcc/config/sparc/sparc.md"
(TARGET_V9))
            return -1;
          return 262; /* speculation_barrier */

        case 3:
          x3 = XVECEXP (x1, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 267; /* flush_register_windows */

        case 5:
          x3 = XVECEXP (x1, 0, 0);
          operands[0] = x3;
          if (!memory_operand (operands[0], E_SImode))
            return -1;
          return 268; /* flushsi */

        case 9:
          x3 = XVECEXP (x1, 0, 0);
          operands[0] = x3;
          if (!memory_operand (operands[0], E_SImode)
              || !
#line 7472 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 269; /* ldfsr */

        default:
          return -1;
        }

    case EH_RETURN:
      return 258; /* eh_return_internal */

    case RETURN:
      return 259; /* *return_internal */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 2
          || XINT (x1, 1) != 1
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 264; /* update_return */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 265; /* nop */

    case PREFETCH:
      x29 = XEXP (x1, 0);
      operands[0] = x29;
      x31 = XEXP (x1, 1);
      operands[1] = x31;
      if (const_int_operand (operands[1], E_DImode)
          && address_operand (operands[0], E_DImode))
        {
          x32 = XEXP (x1, 2);
          operands[2] = x32;
          if (const_int_operand (operands[2], E_DImode))
            return 275; /* prefetch_64 */
        }
      if (!const_int_operand (operands[1], E_SImode)
          || !address_operand (operands[0], E_SImode))
        return -1;
      x32 = XEXP (x1, 2);
      operands[2] = x32;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      return 276; /* prefetch_32 */

    case TRAP_IF:
      x29 = XEXP (x1, 0);
      switch (GET_CODE (x29))
        {
        case CONST_INT:
          if (XWINT (x29, 0) != 1L)
            return -1;
          x31 = XEXP (x1, 1);
          if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          return 277; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[0] = x29;
          if (!icc_comparison_operator (operands[0], E_VOIDmode))
            return -1;
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != REG
              || REGNO (x30) != 100)
            return -1;
          x33 = XEXP (x29, 1);
          if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x31 = XEXP (x1, 1);
          operands[1] = x31;
          if (!arith_operand (operands[1], E_SImode))
            return -1;
          switch (GET_MODE (x30))
            {
            case E_CCmode:
              return 278; /* *trapsi_insn */

            case E_CCXmode:
              if (!
#line 7920 "../../gcc/config/sparc/sparc.md"
(TARGET_V9))
                return -1;
              return 279; /* *trapdi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
