/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  return pattern0 (x5); /* [-1, 2] */
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern20 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern20 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  if (!icc_register_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 102
      || GET_MODE (x2) != E_DImode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1DImode:
      return pattern20 (x1, 
E_V1DImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern20 (x1, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern20 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern20 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != NE
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern76 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern84 (rtx x1, machine_mode i1, rtx_code i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != LTU
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 2
      || XINT (x7, 1) != i3
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (GET_CODE (x8) != i2
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x7, 0, 1);
  if (GET_CODE (x9) != LTU
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 100
      || GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x9, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern105 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_or_zero_operand (operands[1], i1)
      || !register_or_zero_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x5, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x10, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern22 (x3, 
E_SImode) != 0
              || !
#line 4579 "../../gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL))
            return -1;
          return 142; /* *mulsi3_sp32 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern22 (x3, 
E_DImode) != 0
              || !
#line 4619 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          *pnum_clobbers = 2;
          return 143; /* muldi3_v8plus */

        case E_TFmode:
          if (pattern4 (x3, 
E_TFmode) != 0
              || !
#line 6090 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 205; /* *multf3_hq */

        case E_DFmode:
          if (pattern4 (x3, 
E_DFmode) != 0
              || !
#line 6098 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 206; /* muldf3 */

        case E_SFmode:
          if (pattern4 (x3, 
E_SFmode) != 0
              || !
#line 6107 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 207; /* mulsf3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern44 (x3) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 4670 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            {
              *pnum_clobbers = 1;
              return 145; /* mulsidi3_v8plus */
            }
          if (!
#line 4693 "../../gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
            return -1;
          return 147; /* *mulsidi3_sp32 */

        case CONST_INT:
          operands[2] = x5;
          if (!small_int_operand (operands[2], E_DImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 4682 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            {
              *pnum_clobbers = 1;
              return 146; /* const_mulsidi3_v8plus */
            }
          if (!
#line 4720 "../../gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
            return -1;
          return 148; /* const_mulsidi3_sp32 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern44 (x3) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 4872 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            {
              *pnum_clobbers = 1;
              return 154; /* umulsidi3_v8plus */
            }
          if (!
#line 4883 "../../gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
            return -1;
          return 155; /* *umulsidi3_sp32 */

        case CONST_INT:
          operands[2] = x5;
          if (!uns_small_int_operand (operands[2], E_DImode))
            return -1;
          if (
#line 4910 "../../gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
            return 156; /* const_umulsidi3_sp32 */
          if (pnum_clobbers == NULL
              || !
#line 4936 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          *pnum_clobbers = 1;
          return 157; /* const_umulsidi3_v8plus */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != FLOAT_EXTEND)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern76 (x3, 
E_SFmode, 
E_DFmode) != 0
              || !
#line 6187 "../../gcc/config/sparc/sparc.md"
(TARGET_FSMULD))
            return -1;
          return 216; /* *muldf3_extend */

        case E_TFmode:
          if (pattern76 (x3, 
E_DFmode, 
E_TFmode) != 0
              || !
#line 6196 "../../gcc/config/sparc/sparc.md"
((TARGET_V8 || TARGET_V9) && TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 217; /* *multf3_extend */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern48 (x3, 
E_SFmode) != 0
                  || !
#line 9380 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 516; /* *nmulsf3 */

            case E_DFmode:
              if (pattern48 (x3, 
E_DFmode) != 0
                  || !
#line 9388 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 517; /* *nmuldf3 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          if (GET_MODE (x7) != E_DFmode)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != FLOAT_EXTEND
              || GET_MODE (x5) != E_DFmode
              || !register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || GET_MODE (x4) != E_DFmode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SFmode)
              || !
#line 9399 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 518; /* *nmuldf3_extend */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case HIGH:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !immediate_operand (operands[2], E_SImode)
              || !
#line 1698 "../../gcc/config/sparc/sparc.md"
(!flag_pic))
            return -1;
          return 46; /* *movsi_lo_sum */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (symbolic_operand (operands[2], E_DImode))
            {
              if (
#line 1989 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDLOW && !flag_pic))
                return 56; /* *losum_di_medlow */
              if (
#line 2011 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDMID && !flag_pic))
                return 59; /* setl44 */
              if (
#line 2040 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDANY && !flag_pic))
                return 63; /* setlo */
            }
          if (data_segment_operand (operands[2], E_DImode)
              && 
#line 2054 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
            return 65; /* embmedany_losum */
          if (!text_segment_operand (operands[2], E_DImode)
              || !
#line 2090 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
            return -1;
          return 70; /* embmedany_textlo */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !fp_const_high_losum_operand (operands[2], E_SFmode))
            return -1;
          return 72; /* *movsf_lo_sum */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x5, 0))
        {
        case 1:
          switch (XINT (x5, 1))
            {
            case 0:
              if (pattern58 (x3, 
E_SImode) != 0
                  || !immediate_operand (operands[2], E_SImode)
                  || !
#line 1714 "../../gcc/config/sparc/sparc.md"
(flag_pic))
                return -1;
              return 48; /* movsi_lo_sum_pic */

            case 6:
              if (pattern59 (x3, 
E_DImode) != 0
                  || !
#line 2004 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDMID && !flag_pic))
                return -1;
              return 58; /* setm44 */

            case 13:
              if (pattern59 (x3, 
E_DImode) != 0
                  || !
#line 2033 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDANY && !flag_pic))
                return -1;
              return 62; /* sethm */

            case 12:
              if (pattern58 (x3, 
E_DImode) != 0
                  || !text_segment_operand (operands[2], E_DImode)
                  || !
#line 2083 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
                return -1;
              return 69; /* embmedany_textulo */

            case 17:
              if (pattern58 (x3, 
E_SImode) != 0
                  || !tgd_symbolic_operand (operands[2], E_VOIDmode))
                return -1;
              return 281; /* tgd_lo10si */

            case 18:
              if (GET_MODE (x5) != E_SImode)
                return -1;
              x6 = XVECEXP (x5, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 285; /* tldm_lo10si */

            case 19:
              if (pattern58 (x3, 
E_SImode) != 0
                  || !tld_symbolic_operand (operands[2], E_VOIDmode))
                return -1;
              return 289; /* tldo_lox10si */

            case 20:
              if (pattern58 (x3, 
E_SImode) != 0
                  || !tie_symbolic_operand (operands[2], E_VOIDmode))
                return -1;
              return 292; /* tie_lo10si */

            case 21:
              if (pattern58 (x3, 
E_SImode) != 0
                  || !tle_symbolic_operand (operands[2], E_VOIDmode))
                return -1;
              return 295; /* tle_lox10si */

            default:
              return -1;
            }

        case 2:
          if (XINT (x5, 1) != 4
              || pattern59 (x3, 
E_SImode) != 0)
            return -1;
          x7 = XVECEXP (x5, 0, 1);
          operands[3] = x7;
          if (!
#line 1790 "../../gcc/config/sparc/sparc.md"
(flag_pic))
            return -1;
          return 52; /* *movsi_lo_sum_pic_label_ref */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == SUBREG
      && known_eq (SUBREG_BYTE (x3), 4)
      && pattern29 (x3) == 0)
    {
      res = recog_27 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != COMPARE
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 100
      || GET_MODE (x7) != E_CCmode)
    return -1;
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 198; /* *cmp_cc_set */
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[1] = x3;
      if (!icc_comparison_operator (operands[1], E_SImode))
        return NULL;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!icc_register_operand (operands[2], E_VOIDmode)
          || !
#line 1350 "../../gcc/config/sparc/sparc.md"
(TARGET_V9
   /* 64-bit LTU is better implemented using addxc with VIS3.  */
   && !(GET_CODE (operands[1]) == LTU
	&& (GET_MODE (operands[2]) == CCXmode
	    || GET_MODE (operands[2]) == CCXCmode)
	&& TARGET_VIS3)
   /* 32-bit LTU/GEU are better implemented using addx/subx.  */
   && !((GET_CODE (operands[1]) == LTU || GET_CODE (operands[1]) == GEU)
	&& (GET_MODE (operands[2]) == CCmode
	    || GET_MODE (operands[2]) == CCCmode))))
        return NULL;
      return gen_split_11 (insn, operands);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && const_int_operand (operands[1], E_DImode)
              && 
#line 2118 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && ((GET_CODE (operands[0]) == REG
        && SPARC_INT_REG_P (REGNO (operands[0])))
       || (GET_CODE (operands[0]) == SUBREG
           && GET_CODE (SUBREG_REG (operands[0])) == REG
           && SPARC_INT_REG_P (REGNO (SUBREG_REG (operands[0])))))))
            return gen_split_12 (insn, operands);
          if (!memory_operand (operands[0], E_DImode)
              || !const_zero_operand (operands[1], E_DImode)
              || !
#line 2185 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
	   && !mem_min_alignment (operands[0], 8)))
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_16 (insn, operands);

        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || !const_zero_operand (operands[1], E_TImode)
              || !
#line 2278 "../../gcc/config/sparc/sparc.md"
(reload_completed))
            return NULL;
          return gen_split_18 (insn, operands);

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !fp_const_high_losum_operand (operands[1], E_SFmode)
              || !
#line 2446 "../../gcc/config/sparc/sparc.md"
(REG_P (operands[0]) && SPARC_INT_REG_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_21 (insn, operands);

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode))
            {
              if (const_double_operand (operands[1], E_DFmode)
                  && 
#line 2517 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && REG_P (operands[0])
   && SPARC_INT_REG_P (REGNO (operands[0]))
   && !const_zero_operand (operands[1], GET_MODE (operands[0]))))
                return gen_split_22 (insn, operands);
              if (const_zero_operand (operands[1], E_DFmode)
                  && 
#line 2561 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && ((GET_CODE (operands[0]) == REG
	&& SPARC_INT_REG_P (REGNO (operands[0])))
       || (GET_CODE (operands[0]) == SUBREG
	   && GET_CODE (SUBREG_REG (operands[0])) == REG
	   && SPARC_INT_REG_P (REGNO (SUBREG_REG (operands[0])))))))
                return gen_split_23 (insn, operands);
            }
          if (!memory_operand (operands[0], E_DFmode)
              || !const_zero_operand (operands[1], E_DFmode)
              || !
#line 2615 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
	   && !mem_min_alignment (operands[0], 8)))
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_27 (insn, operands);

        case E_TFmode:
          if (!nonimmediate_operand (operands[0], E_TFmode)
              || !const_zero_operand (operands[1], E_TFmode)
              || !
#line 2714 "../../gcc/config/sparc/sparc.md"
(reload_completed))
            return NULL;
          return gen_split_29 (insn, operands);

        case E_V1DImode:
          if (!memory_operand (operands[0], E_V1DImode)
              || !const_zero_operand (operands[1], E_V1DImode)
              || !
#line 8558 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_68 (insn, operands);

        case E_V2SImode:
          if (!memory_operand (operands[0], E_V2SImode)
              || !const_zero_operand (operands[1], E_V2SImode)
              || !
#line 8558 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_69 (insn, operands);

        case E_V4HImode:
          if (!memory_operand (operands[0], E_V4HImode)
              || !const_zero_operand (operands[1], E_V4HImode)
              || !
#line 8558 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_70 (insn, operands);

        case E_V8QImode:
          if (!memory_operand (operands[0], E_V8QImode)
              || !const_zero_operand (operands[1], E_V8QImode)
              || !
#line 8558 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_71 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (register_operand (operands[0], E_DImode))
            {
              if (register_operand (operands[1], E_DImode)
                  && 
#line 2146 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
           && sparc_split_reg_reg_legitimate (operands[0], operands[1])))))
                return gen_split_13 (insn, operands);
              if (memory_operand (operands[1], E_DImode)
                  && 
#line 2161 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_14 (insn, operands);
            }
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 2173 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_15 (insn, operands);

        case E_TImode:
          if (register_operand (operands[0], E_TImode))
            {
              if (register_operand (operands[1], E_TImode)
                  && 
#line 2243 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && ((TARGET_FPU
        && !TARGET_HARD_QUAD)
       || (!fp_register_operand (operands[0], TImode)
           && !fp_register_operand (operands[1], TImode)))))
                return gen_split_17 (insn, operands);
              if (memory_operand (operands[1], E_TImode)
                  && 
#line 2306 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && offsettable_memref_p (operands[1])
   && (!TARGET_HARD_QUAD
       || !fp_register_operand (operands[0], TImode))))
                return gen_split_19 (insn, operands);
            }
          if (!memory_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 2340 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && offsettable_memref_p (operands[0])
   && (!TARGET_HARD_QUAD
       || !fp_register_operand (operands[1], TImode))))
            return NULL;
          return gen_split_20 (insn, operands);

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode))
            {
              if (register_operand (operands[1], E_DFmode)
                  && 
#line 2578 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
	   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))))
                return gen_split_24 (insn, operands);
              if (memory_operand (operands[1], E_DFmode)
                  && 
#line 2591 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_25 (insn, operands);
            }
          if (!memory_operand (operands[0], E_DFmode)
              || !register_operand (operands[1], E_DFmode)
              || !
#line 2603 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_26 (insn, operands);

        case E_TFmode:
          if (register_operand (operands[0], E_TFmode))
            {
              if (register_operand (operands[1], E_TFmode)
                  && 
#line 2678 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && (TARGET_ARCH32
       || (TARGET_FPU
           && !TARGET_HARD_QUAD)
       || (!fp_register_operand (operands[0], TFmode)
           && !fp_register_operand (operands[1], TFmode)))))
                return gen_split_28 (insn, operands);
              if (memory_operand (operands[1], E_TFmode)
                  && 
#line 2742 "../../gcc/config/sparc/sparc.md"
((reload_completed
    && offsettable_memref_p (operands[1])
    && (TARGET_ARCH32
	|| !TARGET_HARD_QUAD
	|| !fp_register_operand (operands[0], TFmode)))))
                return gen_split_30 (insn, operands);
            }
          if (!memory_operand (operands[0], E_TFmode)
              || !register_operand (operands[1], E_TFmode)
              || !
#line 2777 "../../gcc/config/sparc/sparc.md"
((reload_completed
    && offsettable_memref_p (operands[0])
    && (TARGET_ARCH32
	|| !TARGET_HARD_QUAD
	|| !fp_register_operand (operands[1], TFmode)))))
            return NULL;
          return gen_split_31 (insn, operands);

        case E_V1DImode:
          if (register_operand (operands[0], E_V1DImode))
            {
              if (register_operand (operands[1], E_V1DImode)
                  && 
#line 8519 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_56 (insn, operands);
              if (memory_operand (operands[1], E_V1DImode)
                  && 
#line 8532 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_60 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V1DImode)
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 8545 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_64 (insn, operands);

        case E_V2SImode:
          if (register_operand (operands[0], E_V2SImode))
            {
              if (register_operand (operands[1], E_V2SImode)
                  && 
#line 8519 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_57 (insn, operands);
              if (memory_operand (operands[1], E_V2SImode)
                  && 
#line 8532 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_61 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V2SImode)
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 8545 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_65 (insn, operands);

        case E_V4HImode:
          if (register_operand (operands[0], E_V4HImode))
            {
              if (register_operand (operands[1], E_V4HImode)
                  && 
#line 8519 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_58 (insn, operands);
              if (memory_operand (operands[1], E_V4HImode)
                  && 
#line 8532 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_62 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V4HImode)
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 8545 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_66 (insn, operands);

        case E_V8QImode:
          if (register_operand (operands[0], E_V8QImode))
            {
              if (register_operand (operands[1], E_V8QImode)
                  && 
#line 8519 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_59 (insn, operands);
              if (memory_operand (operands[1], E_V8QImode)
                  && 
#line 8532 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_63 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V8QImode)
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 8545 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_67 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      if (GET_MODE (x3) != E_TFmode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (!icc_or_fcc_comparison_operator (x5, E_VOIDmode))
        return NULL;
      operands[1] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_TFmode))
        return NULL;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!icc_or_fcc_register_operand (operands[2], E_VOIDmode))
        return NULL;
      x4 = XEXP (x3, 1);
      operands[3] = x4;
      if (!register_operand (operands[3], E_TFmode))
        return NULL;
      x8 = XEXP (x3, 2);
      operands[4] = x8;
      if (!register_operand (operands[4], E_TFmode)
          || !(
#line 2928 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && !TARGET_HARD_QUAD) && 
#line 2930 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
        return NULL;
      return gen_split_32 (insn, operands);

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode)
              || !(
#line 3147 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3149 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_33 (insn, operands);

        case PLUS:
          if (pattern54 (x5, 
PLUS) != 0)
            return NULL;
          x7 = XEXP (x5, 0);
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!arith_operand (operands[2], E_SImode)
              || !(
#line 3917 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3919 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_37 (insn, operands);

        case MINUS:
          if (pattern54 (x5, 
MINUS) != 0)
            return NULL;
          x7 = XEXP (x5, 0);
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_or_zero_operand (operands[1], E_SImode))
            return NULL;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!arith_operand (operands[2], E_SImode)
              || !(
#line 4332 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4334 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_42 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      switch (pattern12 (x3))
        {
        case 0:
          if (!(
#line 6266 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD) && 
#line 6268 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_51 (insn, operands);

        case 1:
          if (!(
#line 6307 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9) && 
#line 6309 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_52 (insn, operands);

        default:
          return NULL;
        }

    case ABS:
      switch (pattern12 (x3))
        {
        case 0:
          if (!(
#line 6370 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD) && 
#line 6372 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_53 (insn, operands);

        case 1:
          if (!(
#line 6411 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9) && 
#line 6413 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_54 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
